/*		Copyright (c) 1988 Motorola, Inc.		*/
/*		All Rights Reserved				*/
/*  		@(#)pcc.c	35.2	*/
/*
 *	Driver for the Peripheral Channel Controller (PCC) 
 *		on the MVME147 board
 *
 */

#include "sys/mvmecpu.h"
#include "sys/pcc.h"

extern int cpuboard;
extern short waitrmc;

#define VECBASE	0x40	/* Base Vector for the PCC */

extern 	struct	pcc	*pcc_addr[];
extern 	int 	z530_ilev[];	/* interrupt level, from conf.c */

void pccinit()
{
	register struct pcc *addr;

	addr = pcc_addr[0];
	addr->gpcr &= ~PCC_PARMSK;	/* clear previous mode setting */
	addr->acfcr = 0;	/* disable AC fail interrupt */
	addr->spicr = PCC_SIENAB | z530_ilev[0];
	addr->gpcr  |= PCC_MINTEN; /* enable master interrupt */
	addr->ibvr = VECBASE;
	  /* enable WAITRMC if VME147 and waitrmc is nonzero */
	if (cpuboard == VME147 && waitrmc) {
		addr->sbar |= PCC_WAITRMC;
	}
}
