/*
 *	The following are routines for the Unix clock. The DUART interrupts
 *	at 60 times per second. 
 *
 *      Author P.Callow
 */
#include "sys/param.h"
#include "sys/types.h"
#include "sys/sysmacros.h"
#include "sys/dir.h"
#include "sys/signal.h"
#include "sys/user.h"
#include "sys/tty.h"
#include "sys/termio.h"
#include "sys/errno.h"
#include "sys/sysinfo.h"
#include "sys/conf.h"
#include "sys/MC68681.h"

extern struct mc68681 *port_addr[];

fvme252_clkstop()
{
	struct mc68681 *d;

	d = port_addr[0];
	d->d_bcsop = 0x00;	/* Mask out all interrupts */
}


fvme252_clkstart()
{
	register struct mc68681 *d;
	register uint i;

	/* Enable DUART to interrupt unix every 1/60 second */

#ifdef	NOCLOCK
	printf("NO CLOCK ! \n");
#else
	d = port_addr[0];
	i = d->d_ecrop;	
	d->d_ipac = 0x50;	/* External (ip2) divided by 16 */ 
	d->d_ipopc = 0x04;
	d->d_ctu = 0x02;	/* 0x02 C/t upper register */
	d->d_ctl = 0x09;	/* 0x09 C/t lower register */	
	d->d_isim = 0x08;	/* Enable interrupt */
	i = d->d_bcsop;		/* Start counter command */	
#endif

}

fvme252_clkreld(on)
int on;
{
	register char d;

	if (on)  {
		/* Reset DUART timer interrupt */
		asm("tst.b	0xFFF4000F");
		/* d = *((char *)(port_addr[0] + 0x0f)); */
	}
	else {
		asm("mov.b	&0xF7, %d0");
		asm("mov.b	%d0, 0xFFF4000D");
		/* Stop DUART timer */
		/* *((char *)(port_addr[0] + 0x0d)) = 0xF7; */
	}
	return(0);
}

