#
#	Copyright (c) 1985 AT&T
#	Copyright (c) 1988 Motorola Inc
#	All Rights Reserved
#	@(#)equates.m	35.4

#  General equate file.
#  This file contains equates which are used throughout the machine
#  language routines.  Any equate of this nature should be placed in
#  this file.  Equates that are specific to a single machine language
#  source file should be defined in the source file that contains them.

set	allfpi,0xff		# Floating point register save/restore mask.
set	savmsk,0xfcff		# this mask determines which registers are saved
set	regsize,14*4		# Size of mem required to save them.
				#  Currently this mask causes D0..D7 and A2..A7.

set	u,0x4000000		# Address of U-block
	global u		# Define the U-block for the entire system

#
#  Cache control functions.
#

#  Bits 4-0 are the only bits used by 020 in the CACR.
#  All other bits are read as zeros and ignored when written by 020.
#  Bits 13-8 and 4-0 are the only bits used by 030 in the CACR.
#  All other bits are read as zeros and ignored when written by 030.
#  For future compatibility, writes should not set bits 31-14 and 7-5.

set	CACHDIS,0x808		# Cache disable and flush
set	CACHENB,0x2919		# Cache enable and flush and WA
set	CACHDCLR,0xFFFFFFF7	# Don't clear instruction cache mask

set	BTOL,2			# Number of shifts for bytes to longs.

#  Ublock equates.  The following may need changing when the user.h
# file is changed.

set	u_procp,0x1b8
set	u_caddrflt,0x70
set	u_prof,0x244

#  Proc equates.  The following may need changing when proc.h changes.
#

set	p_sysid,0x62

#
#  fpu.h equates.
#

set	fp_regs,64
set	fp_contr,160
set	fp_fsave,172
