#
#	Copyright (c) 1985 AT&T
#	Copyright (c) 1988 Motorola Inc
#	All Rights Reserved
#	@(#)mmb.s	35.4

# mmbstore(reg, val)		/* store to mmu register */
# register char *reg;	
# register int val;	
	data
	global mmbad
mmbad:	long 0x10000
	text
	global	mmbstore
mmbstore:
	link	%fp,&0
	mov.l	12(%fp),%d1	# get parameter "val"
	tst.w	do_pmmu
	bne	pmmustore
	mov.l	8(%fp),%a1
#
	add.l	mmbad,%a1	# MMU access address
	mov.l	%dfc,%a0
	mov.l	&7,%d0		# CPU space function code
	mov.l	%d0,%dfc
	movs.l	%d1,(%a1)	# move to MMU register 
	mov.l	%a0,%dfc
L%189:
	unlk	%fp
	rts

pmmustore:
	mov.l	8(%fp),%d0	# Get "reg" in d0.
				# Check for crp register?
	bne	tcreg		# must be tc register

	mov.l	%d1,rpstore+4	# store root pointer address.
	nop
	short	0xf039		# "pmove rpstore,crp"
	short	0x4c00
	long	rpstore
	nop
	short	0xf000		# "pflusha"
	short	0x2400
	bra	mmbrts

tcreg:
	nop
	short	0xf02e		# store tc register.
	short	0x4000		# "pmove.l 12(%fp),tc"
	short	0x000c

mmbrts:
	unlk	%fp
	rts

#  This is a work around for mask m00a99a.
	data

trp:
	long	0x7fff0002
	long	0x05010

	text

	global	wakemmu
wakemmu:
	tst.w	do_pmmu
	beq	wakeret
	movm.l	&0x0340,-(%sp)		# Save registers.

	mov.l	&7,%d7
	mov.l	%d7,%dfc
	mov.l	%d7,%sfc
	clr.l	%d6
	movs.l	%d6,0x20010

	movs.w	%d6,0x20002

	lea	trp,%a1

	nop
	long	0xf0114c00

	nop
	short	0xf127
	mov.l	&0x2211,0x18(%a7)
	mov.l	0x1c(%a7),%d6

	and.l	&0xff100380,%d6
	or.l	&0x006e5420,%d6
	mov.l	%d6,0x1c(%a7)

	nop
	short	0xf15f

	movs.w	0x20000,%d6

	nop
	long	0xf0072400

	nop
	short	0xf127

	mov.l	&0x4c00,0x18(%a7)
	mov.l	0x1c(%a7),%d6
	and.l	&0xff300380,%d6
	or.l	&0x00425020,%d6
	mov.l	%d6,0x1c(%a7)

	nop
	short	0xf15f

	movs.w	0x20000,%d6

	lea	trp,%a1

	nop
	long	0xf0116000

	mov.l	&UD,%d7
	mov.l	%d7,%sfc
	mov.l	%d7,%dfc

	movm.l	(%sp)+,&0x02c0
wakeret:
	rts

# tt0store(val)			/* store to tt0 register */
# register int val;	
	global	tt0store
tt0store:
	link	%fp,&0

	short	0xf02e		# store tt0 register.
	short	0x0800		# "pmove.l 8(%fp),tt0"
	short	0x0008
	bra	mmbrts

# tt1store(val)			/* store to tt1 register */
# register int val;	
	global	tt1store
tt1store:
	link	%fp,&0

	short	0xf02e		# store tt1 register.
	short	0x0c00		# "pmove.l 8(%fp),tt1"
	short	0x0008
	bra	mmbrts

#
#  The following routine determines whether we're executing on
#  a 68020 or 68030 processor.  If a pmmu is not found then it
#  is assumed that we are executing on an '020 processor board.
	text
	global	chk_030
chk_030:
	mov.l	%vbr,%a0
	mov.l	0x2c(%a0),-(%sp)	# save line f vector
	mov.l	&linef,0x2c(%a0)	# plug our own vector for line f

	clr.l	do_030			# assumes not an '030 before tests
	
	nop
	short	0xf000			# pflusha
	short	0x2400

	mov.l	&illgl,0x2c(%a0)	# plug another vector for line f

	nop
	short	0xf000			# load d0 with tc register.
	short	0x4200			# pmove.l %tc,%d0

ret_030:
	mov.l	(%sp)+,0x2c(%a0)	# restore old handler for line f
	mov.l	do_030,%d0		# load d0 with return value
	rts

illgl:					# pmove.l %tc,%d0 was illegal
	mov.b	&1,do_030+3		# must be an '030, set do_030
linef:					# no pmmu present
	mov.l	&ret_030,2(%sp)         # store return address
	rte

	data
do_030:
	long	0			# Zero value indicates not '030

#
#  The following routine sets the global flag "do_pmmu" to indicate
#  whether or not a PMMU was found.
	text
	global	chk_mmu
chk_mmu:
	mov.l	%vbr,%a0	# Save F line handler
	mov.l	0x2C(%a0),-(%sp)
	mov.l	&chk_mmu6,0x2c(%a0)

	short	0xf000		# "pflusha"
	short	0x2400

	mov.w	&1,do_pmmu
chk_mmu4:
	mov.l	(%sp)+,0x2c(%a0)	# Restore old handler.
	rts

chk_mmu6:
	clr.w	do_pmmu
	mov.l	&chk_mmu4,2(%sp)
	rte

	data
	global	do_pmmu
do_pmmu:
	short	0		# Set to indicate pmmu present.

	global	rpstore
rpstore:
	long	0x7fff0003
	long	0
	
	text

# Get information from the pmmu by doing a 'ptestw' instruction.
# This routine will do a ptestw of level 0 (the ATC) only.
# Read the pmmu's psr and return it's value.
#
# chk_atc(func_code, vaddr)
# register int func_code;	supervisor or user, text or data	
# register int vaddr;		fault address

	text
	global	chk_atc
chk_atc:
	clr	%d0			# clear return value
	tst.w	do_pmmu			#
	beq	atc_rtn			#
	mov.l	0x4(%sp),%d1		# get function code
	long	0xf0378009		# ptestw  d1,([8,%sp]),&0
	long	0x01610008		#
	sub.l	&2,%sp			# make room for psr
	long	0xf0176200		# pmove.w psr,(%sp)
	mov.w	(%sp)+,%d0		# get return value into d0
atc_rtn:
	rts

# Get information from the pmmu by doing a 'ptestw' instruction.
# This routine will do a ptestw of level 7 (causes a tree walk of 
# all levels).
# Read the pmmu's psr and return it's value.
#
# chk_tree(func_code, vaddr)
# register int func_code;	
# register int vaddr;	

	text
	global	chk_tree
chk_tree:
	clr.l	%d0			# clear return value
	tst.w	do_pmmu			#
	beq	tree_rtn		#
	mov.l	0x4(%a7),%d1		# get function code
	long	0xf0379c09		# ptestw  d1,([8,%a7]),&7
	long	0x01610008		#
	sub.l	&2,%sp			# make room for psr
	long	0xf0176200		# pmove.w psr,(%sp)
	mov.w	(%sp)+,%d0		# get return value into d0
tree_rtn:
	rts
