#ident "@(#)arp.h	35.3"

/*
 * Copyright (c) 1987, Motorola Microcomputer Division.  All rights reserved.
 * definition of ARP header as per RFC 826
 */

typedef struct {
	unsigned short ar_hrd;	/* Hardware address space */
	unsigned short ar_pro;	/* Protocol address space */
	unsigned char ar_hln;	/* hardware address length */
	unsigned char ar_pln;	/* protocol address length */
	unsigned short ar_op;	/* opcode */
	e_addr ar_sha;		/* senders hardware address */
	unsigned long ar_spa;	/* senders protocol address */
	e_addr ar_tha;		/* target hardware address */
	unsigned long ar_tpa;	/* target protocol address */
} ARPHDR;

/*
 * defines (RFC 900)
 */
#define REQUEST		1	/* request resolution	*/
#define REPLY		2	/* reply with mapping	*/

/*
 * Hardware Space Definitions
 *
 */
#define ETHERNET	1	/* 10mb ethernet 	*/
#define SLOWENET        2       /* 3mb ethernet         */
#define PKTRADIO        3       /* packet radio AX.25   */
#define PRONET          4       /* Proteon PRONET token */
#define CHAOS           5       /* grandfather          */
#define IEEE802         6       /* IEEE 802 Snap nets   */

/*
 * ARP mapping table
 *
 * Each network interface has its own ARP mapping table.
 */
#define TSIZE		128		/* size of ARP table	*/

struct arptab {
	HOST in_addr;			/* my internet address 	*/
	e_addr et_addr;			/* my ethernet address	*/
	ushort my_hrd;                  /* my hardware space    */
	uchar  my_hln;                  /* my hardware length   */
	uchar  timer;			/* flag: timer running	*/
	struct arptable {
		unsigned long	in_addr;		/* internet address */
		union {
			e_addr		et_addr;	/* ethernet address */
			mblk_t		*pkt;		/* pending xmit	    */
		} a_u;
		uchar		age;			/* table entry age  */
		uchar		flags;			/* entry flags	    */
	} tab[TSIZE];
};

/*
 * ARP table entry flags
 */
#define ARP_PENDING		0x01			/* pkt pending	   */
#define ARP_PERM		0x02			/* permanent entry */
