/*
 *
 * Copyright (c) 1987, Motorola Microcomputer Division.  All rights reserved.
 *
 * Definitions pertaining to the Ethernet
 */
#ident "@(#)ether.h	35.1"

/*
 * Ethernet hardware address
 */
typedef	struct	{
	unsigned char	octet[6];
} e_addr;

/*
 * Ethernet frame
 */
typedef struct {
	e_addr	eth_dest;		/* 48-bit destination address	*/
	e_addr	eth_src;		/* 48-bit source address	*/
	unsigned short	eth_type;	/* ethernet frame 16-bit type field */
} e_frame;

#define ETYP_RAW        0x000           /* raw interface ( no implied type */
#define ETYP_IP		0x800		/* Ethernet pkt type for IP	*/
#define ETYP_ARP	0x806		/* Ethernet pkt type for ARP	*/
#define ETH_MIN		(6+6+2+46)	/* src+dst+type+data		*/
#define ETH_MAX		(6+6+2+1500)	/* src+dst+type+data		*/
#define ETH_MAXDATA	1500		/* max data of ethernet pkt	*/

/*
 * ethernet interface io control functions
 */
#define EIOCSETEADDR	(('E' << 8) | 0)
#define EIOCSETINADDR	(('E' << 8) | 1)
