static char ident[] = " @(#)ma_dat_con.c	35.2        6/17/88	Copyright MOTOROLA, INC. ";

/*FH*********************** FUNCTION HEADER ***************************
**
**  FUNCTION NAME:	ma_dat_con
**
**  DESCRIPTION:	This function will return to the originator
**			of the MA_DATA_REQUEST primitive an
**			MA_DATA_CONFIRM primitive via an MAC EPB.
**			This primitive will provide an appropriate
**			reply to the LLC sublayer MA_DATA.request
**			primitive signifying the success or
**			failure of the request.
**
**
**  PARAMETERS:		
**
**	Input:		ma_epbptr		: address of MAC EPB
**
**	Output:
**
**	Returns:
**
**  COMPLEX LOCALS:
**
**  METHOD:
**
**  NOTES:
**
**********************************************************************/

/*
**	Include Files
*/

#include <sys/osi/common/types.h>	/* Abstract Type Definitions */
#include <sys/osi/common/system.h>	/* System Function Definitions */
#include <sys/osi/common/bdb.h>		/* BDB Type Definitions */
#include <sys/osi/common/epb.h>		/* EPB Type Definitions */
#include <sys/osi/common/selsizes.h>	/* MAC Address Size */
#include <sys/osi/common/ma_epb.h>	/* MAC EPB Type Definitions */
#include <sys/osi/common/macros.h>	/* Macro Definitions */

#include "ma_lance.h"			/* LANCE Controller Definitions */
#include "ma_def.h"			/* MAC Node Definitions */
#include "ma_globals.h"			/* Global MAC Node Definitions */

VOID
ma_dat_con(ma_epbptr)

register MA_EPB *ma_epbptr;	/* MAC EPB Pointer */
{
	VOID	o_retepb(),	/* Return EPB */
		o_post();	/* Post EPB */

/*
**  If the EPB header status does not contain an error, a
**  MAC_DATA.confirm service request is returned to the originator
**  of the MA_DATA.request. This will include the source/destination
**  address, transmission status and service class.
*/

	if (ma_epbptr->hdr.status == RET_OK)
	{
		if (ma_epbptr->status == RET_OK)
			LOG("MAC: TX'd data confirmed by LANCE\n");

		if (ma_epbptr->hdr.user_def == 0)
		{
			ma_epbptr->hdr.dst_id = ma_epbptr->hdr.src_id;
			ma_epbptr->hdr.src_id = MAC_QID;

			ma_epbptr->Response_Ptr		= (BDB *)NULL;
			ma_epbptr->Response_Status	= 0;
			ma_epbptr->Response_Svc_Class	= 0;

			o_post(ma_epbptr);

			return;
		}
	}

	o_retepb(ma_epbptr);
}
