static char ident[] = " @(#)ma_globals.c	35.2        6/17/88	Copyright MOTOROLA, INC. ";

/*MH*********************** MODULE HEADER ***************************
**
**  MODULE NAME:	ma_globals.c
**
**  DESCRIPTION:	This module contains all the global MAC
**			variables.
**
**  CONTENTS:
**
**  SYSTEM GLOBALS:
**
**  MODULE GLOBALS:
**
**  NOTES:
**
**********************************************************************/

/*
**	Include Files
*/

#include <sys/osi/common/types.h>	/* Abstract Type Definitions */
#include <sys/osi/common/system.h>	/* System Function Definitions */
#include <sys/osi/common/bdb.h>		/* BDB Type Definitions */
#include <sys/osi/common/epb.h>		/* EPB Type Definitions */
#include <sys/osi/common/selsizes.h>	/* MAC Address Size */
#include <sys/osi/common/ma_epb.h>	/* MAC EPB Type Definitions */
#include <sys/osi/common/macros.h>	/* Macro Definitions */

#include "ma_lance.h"			/* LANCE Controller Definitions */
#include "ma_def.h"			/* MAC Node Definitions */


UBYTE	ma_state      = MAC_INIT; /* MAC Task State */

USHORT	ma_board      = 147;	  /* MVME147 Board Number */

UBYTE	*ma_reg_tbl   = 0;	  /* MAC Registration Table */

ULONG	ma_tx_ctr     = 0;	  /* Number of Packets Transmitted */

ULONG	ma_rx_ctr     = 0;	  /* Number of Packets Received */
 
ULONG	ma_ir_ctr     = 0;	  /* Number of Interrupts Processed */

USHORT	ma_ga_mask[4] = {0};	  /* Node's Group Address Mask */

MA_ADDR ma_ts_addr    = {0};	  /* Node's Physical Address */
 
MA_ADDR ma_gladr      =		  /* Broadcast Address */
{
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF
};

struct	initblk	*ma_lnc_iblkptr = 0;	/* LANCE Initialization Block */

struct	ringptr	ma_lnc_rxrgptr  = {0};	/* LANCE RX Descriptor Ring */

struct	ringptr	ma_lnc_txrgptr  = {0};	/* LANCE TX Descriptor Ring */

struct	txbufrng ma_txrgptr     = {0};	/* MAC TX Buffer Ring */

MA_STAT	ma_stat_tbl =			/* MAC Statistics Table */
{
	/*
	**  Transmit related statistics.
	*/

	0,	/* Number Of MAC Packets Transmitted
		   Without Error After More Than One Collision */

	0,	/* Number Of MAC Packets Transmitted
		   Without Error After Exactly One Collision */

	0,	/* Number Of MAC Packet Transmissions
		   Deferred Because Channel Is Busy */

	0,	/* Number Of MAC Packet Transmissions Aborted
		   Due To Lack Of Ownership Of Next Buffer */

	0,	/* Number Of MAC Packet Transmissions
		   Aborted Due To Underflow Error */

	0,	/* Number Of MAC Packet Transmissions
		   Aborted Due To Late Collision */

	0,	/* Number Of MAC Packet Transmissions
		   Aborted Due To Loss Of Carrier */

	0,	/* Number Of MAC Packet Transmissions
		   Aborted Due To Excessive Collisions */

	0,	/* Time Doman Reflectometry Counter */

	/*
	**  Receive related statistics.
	*/

	0,	/* Number Of MAC Packets Received
		   With A Framing Error */

	0,	/* Number Of MAC Packets Received
		   With An Overflow Error */

	0,	/* Number Of MAC Packets Received
		   With An CRC Error */

	0,	/* Number Of MAC Packets Received While Data Chaining
		   But Lost Due To Lack Of Ownership Of Buffer */

	/*
	**  Hardware related statistics.
	*/

	0,	/* Number Of Times The Transmitter
		   Timed Out */

	0,	/* Number Of Times The Transmission
		   Transceiver Test Collision Failed */

	0,	/* Number Of MAC Packets Received
		   But Lost Due To Lack Of Buffers */

	0	/* Number Of Memory Addressing
		   Errors */
};
