static char ident[] = " @(#)ma_rx_gbuf.c	35.2        6/17/88	Copyright MOTOROLA, INC. ";

/*FH*********************** FUNCTION HEADER ***************************
**
**  FUNCTION NAME:	ma_rx_gbuf
**
**  DESCRIPTION:	This function supplies the LANCE Receive
**			Receive Descriptor Ring with free bufferrs
**			for storage of incoming data packets.
**
**  PARAMETERS:		
**
**	Input:		retptr		: pointer to return code
**					  variable
**
**			ma_lnc_rxrgptr	: LANCE Receive Desc Ring
**
**
**	Output:
**
**	Returns:	retptr		: holds return code
**
**  COMPLEX LOCALS:
**
**  METHOD:
**
**  NOTES:
**
**********************************************************************/

/*
**	Include Files
*/

#include <sys/osi/common/types.h>	/* Abstract Type Definitions */
#include <sys/osi/common/system.h>	/* System Function Definitions */
#include <sys/osi/common/bdb.h>		/* BDB Type Definitions */

#include "ma_lance.h"			/* LANCE Controller Definitions */
#include "ma_def.h"			/* MAC Node Definitions */
#include "ma_globals.h"			/* Global MAC Node Definitions */


VOID
ma_rx_gbuf(retptr)

register DEFAULT *retptr; 	/* Pointer To Return Code Variable */
{
	BDB	 *o_getbdb();		 /* Get BDB Block */

	register BDB	*bptr;		 /* Pointer To Data Block */

	register struct ringentry *rptr; /* Pointer To Ring Entry */

/*
**  First, the ring entry byte count is checked for a value
**  of zero (empty entry). If it is not, an error is returned.
**
**  Next, a Data Block is obtained. If the BDB pool is emtpy
**  a NULL pointer will be returned which will cause the function
**  to fall through to the end. This will be returned as an error
**  to the calling function to indicate the shortage of buffers.
**
**  If a buffer was obtained, it is placed in the receive ring at the
**  tail entry. The new buffer is turned over to the LANCE and the
**  ring's tail pointer is incremented
*/

	rptr = ma_lnc_rxrgptr.tail;

	if ((rptr->md[2] == 0) && ((bptr = o_getbdb(BDB_PID)) != (BDB *)NULL))
	{
		bptr->buff_offset = 0;

		LOAD_RING(bptr->data, bptr->buff_size, rptr);

		rptr->md[1] |= RMD1_OWN;

		ma_lnc_rxrgptr.tail = INCR_RING(rptr, ma_lnc_rxrgptr);

		*retptr = RET_OK;
	}
	else
		*retptr = MA_ERR_MEM;
}
