#	Copyright (c) 1984 AT&T
#	  All Rights Reserved

#	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T
#	The copyright notice above does not evidence any
#	actual or intended publication of such source code.

#ident	"@(#)mac.mk	35.2"

STRIP = strip
INCRT = ../..
LIBNAME = ../$(LIBDIR)/lib.lnc
DASHG = 
DASHO = -O
CFLAGS= -I$(INCRT) -DINKERNEL $(DASHG) $(DASHO) $(BRDEFS) -D$(CPU)
ASFLAGS = -m
FRC =

FILES = \
		$(LIBNAME)(ma_dat_con.o)	\
		$(LIBNAME)(ma_dat_ind.o)	\
		$(LIBNAME)(ma_dat_req.o)	\
		$(LIBNAME)(ma_globals.o)	\
		$(LIBNAME)(ma_init.o)		\
		$(LIBNAME)(ma_isr.o)		\
		$(LIBNAME)(ma_isr_asm.o)	\
		$(LIBNAME)(ma_main.o)		\
		$(LIBNAME)(ma_mgmt.o)		\
		$(LIBNAME)(ma_regdreg.o)	\
		$(LIBNAME)(ma_restart.o)	\
		$(LIBNAME)(ma_rx_gbuf.o)

all:	pickup $(LIBNAME) 

.PRECIOUS:	$(LIBNAME)

pickup:
	-@if [ "`ls *.o 2>/dev/null`" ] ; \
	then \
		echo "\t$(AR) ruv $(LIBNAME) *.o" ; \
		$(AR) ruv $(LIBNAME) *.o ; \
		echo "\trm -f *.o" ; \
		rm -f *.o  ; \
	fi

$(LIBNAME):	$(FILES)
	$(AR) ruv $(LIBNAME) *.o
	rm -f *.o

.c.a:
	$(CC) $(CFLAGS) -c -DSHIFT=2 $<

.s.a:
	$(AS) $(ASFLAGS) $<

clean:
	-rm -f *.o

clobber:	clean
	-rm -f $(LIBNAME)

FRC:

#
# Header dependencies
#

$(LIBNAME)(ma_isr_asm.o):	ma_isr_asm.s	\
	$(FRC)

$(LIBNAME)(ma_dat_con.o):	ma_dat_con.c	\
	$(INCRT)/sys/osi/common/types.h		\
	$(INCRT)/sys/osi/common/system.h	\
	$(INCRT)/sys/osi/common/bdb.h		\
	$(INCRT)/sys/osi/common/epb.h		\
	$(INCRT)/sys/osi/common/selsizes.h	\
	$(INCRT)/sys/osi/common/ma_epb.h	\
	$(INCRT)/sys/osi/common/macros.h	\
	ma_lance.h				\
	ma_def.h				\
	ma_globals.h				\
	$(FRC)

$(LIBNAME)(ma_dat_ind.o):	ma_dat_ind.c	\
	$(INCRT)/sys/osi/common/types.h		\
	$(INCRT)/sys/osi/common/system.h	\
	$(INCRT)/sys/osi/common/bdb.h		\
	$(INCRT)/sys/osi/common/epb.h		\
	$(INCRT)/sys/osi/common/selsizes.h	\
	$(INCRT)/sys/osi/common/ma_epb.h	\
	$(INCRT)/sys/osi/common/macros.h	\
	$(INCRT)/sys/osi/common/com_env.h	\
	ma_lance.h				\
	ma_def.h				\
	ma_globals.h				\
	$(FRC)

$(LIBNAME)(ma_dat_req.o):	ma_dat_req.c	\
	$(INCRT)/sys/osi/common/types.h		\
	$(INCRT)/sys/osi/common/system.h	\
	$(INCRT)/sys/osi/common/bdb.h		\
	$(INCRT)/sys/osi/common/epb.h		\
	$(INCRT)/sys/osi/common/selsizes.h	\
	$(INCRT)/sys/osi/common/ma_epb.h	\
	$(INCRT)/sys/osi/common/macros.h	\
	$(INCRT)/sys/bppv2/mvme147/bpp_local.h	\
	ma_lance.h				\
	ma_def.h				\
	ma_globals.h				\
	$(FRC)

$(LIBNAME)(ma_globals.o):	ma_globals.c	\
	$(INCRT)/sys/osi/common/types.h		\
	$(INCRT)/sys/osi/common/system.h	\
	$(INCRT)/sys/osi/common/bdb.h		\
	$(INCRT)/sys/osi/common/epb.h		\
	$(INCRT)/sys/osi/common/selsizes.h	\
	$(INCRT)/sys/osi/common/ma_epb.h	\
	$(INCRT)/sys/osi/common/macros.h	\
	ma_lance.h				\
	ma_def.h				\
	$(FRC)

$(LIBNAME)(ma_init.o):		ma_init.c	\
	$(INCRT)/sys/osi/common/types.h		\
	$(INCRT)/sys/osi/common/system.h	\
	$(INCRT)/sys/osi/common/bdb.h		\
	$(INCRT)/sys/osi/common/epb.h		\
	$(INCRT)/sys/osi/common/selsizes.h	\
	$(INCRT)/sys/osi/common/ma_epb.h	\
	$(INCRT)/sys/osi/common/macros.h	\
	$(INCRT)/sys/osi/common/com_env.h	\
	$(INCRT)/sys/osi/board/mvme147.h	\
	$(INCRT)/sys/nvram.h			\
	ma_lance.h				\
	ma_def.h				\
	ma_globals.h				\
	$(FRC)

$(LIBNAME)(ma_isr.o):		ma_isr.c	\
	$(INCRT)/sys/osi/common/types.h		\
	$(INCRT)/sys/osi/common/system.h	\
	$(INCRT)/sys/osi/common/bdb.h		\
	$(INCRT)/sys/osi/common/epb.h		\
	$(INCRT)/sys/osi/common/selsizes.h	\
	$(INCRT)/sys/osi/common/ma_epb.h	\
	$(INCRT)/sys/osi/common/macros.h	\
	ma_lance.h				\
	ma_def.h				\
	ma_globals.h				\
	$(FRC)

$(LIBNAME)(ma_main.o):		ma_main.c	\
	$(INCRT)/sys/osi/common/types.h		\
	$(INCRT)/sys/osi/common/system.h	\
	$(INCRT)/sys/osi/common/bdb.h		\
	$(INCRT)/sys/osi/common/epb.h		\
	$(INCRT)/sys/osi/common/selsizes.h	\
	$(INCRT)/sys/osi/common/ma_epb.h	\
	$(INCRT)/sys/osi/common/macros.h	\
	$(INCRT)/sys/osi/common/com_env.h	\
	$(INCRT)/sys/bppv2/bpp.h		\
	$(INCRT)/sys/bppv2/bm.h			\
	$(INCRT)/sys/bppv2/ccb.h		\
	$(INCRT)/sys/bppv2/mvme147/bpp_local.h	\
	$(INCRT)/sys/bppv2/mvme147/bp_ci.h	\
	ma_lance.h				\
	ma_def.h				\
	ma_globals.h				\
	$(FRC)

$(LIBNAME)(ma_mgmt.o):		ma_mgmt.c	\
	$(INCRT)/sys/osi/common/types.h		\
	$(INCRT)/sys/osi/common/system.h	\
	$(INCRT)/sys/osi/common/bdb.h		\
	$(INCRT)/sys/osi/common/epb.h		\
	$(INCRT)/sys/osi/common/selsizes.h	\
	$(INCRT)/sys/osi/common/ma_epb.h	\
	$(INCRT)/sys/osi/common/sm_epb.h	\
	$(INCRT)/sys/osi/common/macros.h	\
	$(INCRT)/sys/bppv2/mvme147/bpp_local.h	\
	ma_lance.h				\
	ma_def.h				\
	ma_globals.h				\
	$(FRC)

$(LIBNAME)(ma_regdreg.o):	ma_regdreg.c	\
	$(INCRT)/sys/osi/common/types.h		\
	$(INCRT)/sys/osi/common/system.h	\
	$(INCRT)/sys/osi/common/bdb.h		\
	$(INCRT)/sys/osi/common/epb.h		\
	$(INCRT)/sys/osi/common/selsizes.h	\
	$(INCRT)/sys/osi/common/ma_epb.h	\
	$(INCRT)/sys/osi/common/macros.h	\
	$(INCRT)/sys/osi/common/com_env.h	\
	ma_lance.h				\
	ma_def.h				\
	ma_globals.h				\
	$(FRC)

$(LIBNAME)(ma_restart.o):	ma_restart.c	\
	$(INCRT)/sys/osi/common/types.h		\
	$(INCRT)/sys/osi/common/system.h	\
	$(INCRT)/sys/osi/common/bdb.h		\
	$(INCRT)/sys/osi/common/epb.h		\
	$(INCRT)/sys/osi/common/selsizes.h	\
	$(INCRT)/sys/osi/common/ma_epb.h	\
	$(INCRT)/sys/osi/common/macros.h	\
	ma_lance.h				\
	ma_def.h				\
	ma_globals.h				\
	$(FRC)

$(LIBNAME)(ma_rx_gbuf.o):	ma_rx_gbuf.c	\
	$(INCRT)/sys/osi/common/types.h		\
	$(INCRT)/sys/osi/common/system.h	\
	$(INCRT)/sys/osi/common/bdb.h		\
	ma_lance.h				\
	ma_def.h				\
	ma_globals.h				\
	$(FRC)
