static char ident[] = " @(#)sm_main.c	35.2        6/17/88	Copyright MOTOROLA, INC. ";

/*MH************************ MODULE HEADER ****************************
**
**  MODULE NAME:        sm_main.c
**
**  DESCRIPTION:        Station Manager main module and entry point.
**
**  CONTENTS:           This task pends on the Station Manager queue waiting for
**                      an event to come from the Station Manager console.
**
**  SYSTEM GLOBALS:	none
**
**  MODULE GLOBALS:	none
**
**  NOTES:
**
**********************************************************************/

#include <sys/osi/common/types.h>
#include <sys/osi/common/bdb.h>
#include <sys/osi/common/selsizes.h>
#include <sys/osi/common/epb.h>
#include <sys/osi/common/ma_epb.h>
#include <sys/osi/common/sm_epb.h>
#include <sys/osi/common/system.h>
#include <sys/osi/common/macros.h>
#include <sys/osi/common/com_env.h>

#include <sys/bppv2/bpp.h>
#include <sys/bppv2/bm.h>
#include <sys/bppv2/ccb.h>
#include <sys/bppv2/mvme147/bpp_local.h>
#include <sys/bppv2/mvme147/bp_ci.h>

extern	VOID	o_retepb();
extern	VOID	sm_nvram();	/* NVRAM events	*/
extern	VOID	sm_swap();	/* Swap IDs, post EPB */

/*FH************************ FUNCTION HEADER ****************************
**
**  FUNCTION NAME:	sm_main()
**
**  DESCRIPTION:        This is the main driver for the Station Manager.
**			It registers the Station Manager with the common
**			environment and then pends forever on its queue
**			picking off events and sending them off for processing.
**
**  CONTENTS:           
**
**  SYSTEM GLOBALS:
**
**  MODULE GLOBALS:	none
**
**  NOTES:
**
*************************************************************************/

VOID
sm_main(mpb, arg)

BP_MPB_T	*mpb;		/* pointer to the message */
ULONG		arg;		/* argument is not used for now */
{
	register EPB	*epb;		/* Pointer To EPB */

	LOG("SMA: Processing event\n");

	epb = (EPB *)&(((PSEPB *)mpb)->epb);	/* First adjust pointer */

	switch (epb->type)
	{
		case SM_NVRAM_RD_REQUEST:
		case SM_NVRAM_WR_REQUEST:
		{
			sm_nvram(epb);
			break;
		}

		case SM_LOG_MASK_RD_REQUEST:
		{
			((SM_EPB *)epb)->log_mask = log_mask;
			sm_swap(SM_LOG_MASK_RD_CONFIRM, epb);

			break;
		}

		case SM_LOG_MASK_SET_REQUEST:
		{
			log_mask = ((SM_EPB *)epb)->log_mask;
			o_retepb(epb);

			break;
		}

		/*
		**  If we reach this point, we have been passed an
		**  unrecognizable event. Error processing should occur.
		*/

		default:
		{
			LOG("SMA: unknown event 0x%x\n", epb->type);

			epb->status = -1;
			sm_swap(epb->type, epb);
		}
        }
}
