/*
 *	Copyright (c) 1987 Motorola Inc
 *	All Rights Reserved
 *	@(#)aspen.h	35.1
 */

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF Motorola	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

#ident	"@(#)aspen.h	35.1"

/*
 *	Status and Control registers for the ASPEN prototype.
 *		Status registers are read-only.
 *		Control registers are read/write.
 *		Cache control registers
 */

/*
 *	Status Register
*/

#define	SSR	((int *)0x10000030)	/* ASPEN CPU status register.*/

/*
 *	Control Register
*/
#define	SCR	((char *)0x10000032)	/* ASPEN CPU control register.*/

/*
 *	Cache Control Register
*/
#define	FSCC	((int *)0x10000010)	/* Flush supervisor code cache*/
#define	FSDC	((int *)0x10000014)	/* Flush supervisor data cache*/
#define	FUCC	((int *)0x10000018)	/* Flush usr code cache*/
#define	FUDC	((int *)0x1000001c)	/* Flush user data cache*/

#define	ASR	((char *)0x10000033)	/* VME address expansion register.*/
#define	ASYNC	((int *)0x10000040)	/* Base address of Async chip.*/
/*#define	LANCE	((int *)0x20000800)/* Base address of LANCE chip.*/
#define	ROM	((int *)0x20000000)	/* Start of ASPEN ROM.*/
#define	RTC	((int *)0x20000000)	/* Start of ASPEN RTC.*/
