/*@(#)bpptypes.h	35.1		6/9/88*/
/*IH*********************** INCLUDE HEADER ****************************
**
**  INCLUDE NAME:	bpptypes.h
**
**  DESCRIPTION:	This file contains basic data type definitions for
**			software portability.
**
**  NOTES:
**
**  UPDATE LOG:
**  Date	Name		V/R	Comments
**  --------	-----------   	---	-----------------------------
**  07/10/87	Jim Holbrook	Original coding.
**
**********************************************************************/

#define	BOOLEAN	unsigned char		/* Two valued (TRUE/FALSE)   */
#define	DEFAULT	int			/* Default size		     */

#define	BYTE	char			/* Signed byte (8 bits)	     */
#define	UBYTE	unsigned char		/* Unsigned byte	     */

#define	SHORT	short			/* Signed word (16 bits)     */
#define	USHORT	unsigned short		/* Unsigned word	     */

#define	LONG	long			/* Signed long (32 bits)     */
#define	ULONG	unsigned long		/* Unsigned long	     */

#ifndef NOT_USED
typedef	void	(*PTF)();  		/* Pointer to function type  */
#endif

/*
**  The following are null definitions and may be used with
**  the previously defined declarators for clarity.
*/

#define	LOCAL	/**/			/* Local variable	     */
#define	GLOBAL	/**/			/* Global variable	     */
#define	MODULE	/**/			/* Module variable	     */

/*
**  Miscellaneous definitions.
*/
/*#define	TERMINATOR	0		/* general linked list terminator */

/***************** don't use these in new bpp
#define SUCCESS  1
#define FAILURE  0
*******************/

#define	TRUE	(1)			/* Function TRUE value	     */
#define	FALSE	(0)			/* Function FALSE value	     */

#define	YES	1			/* "TRUE"		     */
#define	NO	0			/* "FALSE"		     */

#define	ON	1			/* "TRUE"		     */
#define	OFF	0			/* "FALSE"		     */

#define	FOREVER	1			/* while ( FOREVER ) loop    */

#define	EOF	(-1)			/* EOF value		     */
#define	NULL	0			/* Null value		     */
#define	NULL_PTR	0		/* Null value			 */
