/*@(#)cit.h	35.1*/
typedef struct cit	/* Channel Initialization Table structure */
{
	USHORT		lcl_cpu;		/* BPP cpu designation for the local processor */
	UBYTE		lcl_cpu_type;	/* Type of this CPU */
	UBYTE		lcl_irq_mode;	/* Mode used by the remote CPU to 
									interrupt the local CPU */
	UBYTE		lcl_irq_level;	/* Interrupt level to use when
									interrupting the local CPU */
	UBYTE		lcl_id_size;	/* size of id/status vector in bytes */
	UBYTE		*lcl_id_vector;	/* Status/ID vector to present on IACK */
	UBYTE		*lcl_irq_addr;	/* Address to use for address-mapped 
									interrupt request method */
	USHORT		lcl_num_bpes;	/* Number of BPEs to create for the local CPU */
	USHORT		rmt_cpu;		/* BPP cpu designation for the remote 
									processor with which the user wishes
									to establish a message channel.  It must 
									be a "pipe responder" type of BPP.  */
	UBYTE		rmt_cpu_type;	/* Type of this CPU */
	UBYTE		rmt_irq_mode;	/* Mode used to interrupt the remote CPU */
	UBYTE		rmt_irq_level;	/* Interrupt level to use when
									interrupting the remote CPU */
	UBYTE		rmt_id_size;	/* size of id/status vector in bytes */
	UBYTE		*rmt_id_vector;	/* Status/ID vector to present on IACK */
	UBYTE		*rmt_irq_addr;	/* Address to use for address-mapped 
									interrupt request method */
	USHORT		rmt_num_bpes;	/* Number of BPEs to create for the remote CPU */
	USHORT		rmt_resp_time;	/* Number of seconds to wait before looking 
									for a response from the remote CPU */
	USHORT		retry_count;	/* Number of times to retry a step during 
									channel initialization. */
	ULONG		(*rmt_intr)()	/* pointer to a board-specific intr function
									to execute instead of the standard
									interrupt function */
	ULONG		rmt_arg;		/* argument to the rmt_intr function */
	ULONG		(*rmt_init)();	/* pointer to board-specific init function 
									to execute instead of the standard 
									initialization function.  This field 
									is NULL if no special function exists. */
	ULONG		(*rmt_probe)();	/* function to probe for presence of
			   						board.  Currently this is either
			   						bprobe or sprobe. */
	ULONG		(*rmt_ctrl_write)();	/* pointer to function that writes
			   						control register address */
	ULONG		(*rmt_data_write)();	/* Pointer to function to write data
			   						to cpu.  We assume that every cpu 
			   						can receive at least a byte. */
	ULONG		(*rmt_status_read)();	/* pointer to function to read status
			   						from the cpu */
	UBYTE		*shared_mem_addr;	/* Pointer to shared memory to use for 
									BPEs and CCB */
	UBYTE		*shared_mem_size;	/* Size of shared memory area for BPEs 
									and CCB. */
} CIT;
