/*		Copyright (c) 1986,1987,1988 Motorola,Inc.	*/
/*		All Rights Reserved				*/
/*		@(#)dsk.h	35.4	*/
/*
 *
 */

struct dsk {
	struct dsk	*d_link;		/* link to next dsk struct */
	unsigned short	d_flags;		/* disk discipline flags   */
	int 		(*d_strategy)();	/* driver strategy routine */
	int		(*d_start)();		/* driver start routine    */
	int		(*d_timer)();		/* driver timer routine    */
	int		(*d_print)();		/* driver print routine    */
	int		d_shorttime;		/* normal cmds time limit  */
	int		d_longtime;		/* long cmd time limit     */
	unsigned char	d_slcbits;		/* bits to define slice    */
};

/*
 *	d_flag bit settings
 */

#define	D_CONFIG	0x01	/* controller's drives need to be configured */
#define	D_DFL_CONF	0x02	/* do default configuration only */
#define	D_SWBAD		0x04	/* controller needs S/W bad track support */
#define	D_TAB		0x08	/* controller needs a "tab" structure */
#define	D_FMTU		0x10	/* controller can support a format unit cmd */
#define D_NOVID		0x20	/* don't read VOLID */
#define	D_DFL_ERR	0x40	/* check for errors for default config */
#define	D_MOTTST	0x80	/* don't allow foreign disks */

/*
 *	Flag settings for the buf flag field; only high order word
 */

#define	B_CONF		0x00010000	/* re-config, vid & cfg blk provided */
#define	B_DFL_CONF	0x00020000	/* default config */
#define B_ABS		0x00040000	/* blk # is absolute, no slice offset */
#define	B_FMTU		0x00080000	/* format unit command */
#define	B_LONGCMD	0x00100000	/* long cmd (e.g. format) (mvme321) */
#define	B_ISTRAT	0x00200000	/* initialize strategy algorithm */
#define	B_ICACHE	0x00400000	/* initialize cache buffers */
#define	B_IPC_CONF	0x00800000	/* IPC write descriptor cmd */
#define	B_FIXBS		0x01000000	/* fix bad spot command */
#define	B_STSRTN	0x80000000	/* status packet returned from IPC */

/*
 *	Flag settings for the iobuf flag field; only high order word
 */

#define	B_DEVDEAD	0x00010000	/* device dead flag */
#define	B_INTPROC	0x00020000	/* interrupt processed flag */
#define	B_WCLOSE	0x00040000	/* close wanted (dev still active) */
#define	B_REINIT	0x00080000	/* re-init drive on re-open */
#define	B_SPECL		0x80000000	/* special device (root, swap, pipe) */

/*
 *	Disk Discipline controlled fields of the iobuf structure
 */

#define	acts		io_s1	/* used for sorting I/O queue */
#define io_qcnt		io_s2	/* number of buffers queued */
#define	io_slccnt	io_s3	/* number of slices as defined in config blk */
#define	io_badptr	io_s4	/* pointer to bad track table (if needed) */
#define	b_acts		io_s5	/* pointer to last buffer sent to the IPC */
#define io_pktcnt	io_s6	/* limit/count of packets for a device */
#define	io_sopen	io_s7	/* open slices flag */
#define	io_slctbl	io_s8	/* pointer to the slice table */
#define	io_dskptr	io_s9	/* pointer to the dsk structure */

struct pktcnt {			/* pktcnt: use of io_pktcnt (io_s6) */
	ushort limit;		/* maximum # of packets that IPC can have */
	ushort cnt;		/* count of packets that IPC currently has */
};

#define	b_pkt		b_umd		/* redefine field in buf struct */

/* for coalescing */
#define	cylin	b_umd		/* holds cylinder number */
#define	coal_soff	b_s1	/* holds sector offset of slice for I/O */


#define	BADBLK	1		/* where should this be defined ??? */
#define	DSKTIMEOUT	10	/* what should this value be ??? */
#define	STEPSIZE 32		/* I/O queue step */
