/*      @(#)mount.h	3.1 LAI System V NFS Release 3.0/V3  source        */

/*
 * Some of this module was taken from Convergent's mount.h:
 *
 *	Convergent Technologies - System V - Nov 1986
 * #ident	@(#)mount.h	35.1
 */

/*
 * Get the nfs specific hidden args to mount system call.
 * From sun mount.h, Convergent modified to pass opaque addresses.
 */
struct nfs_args {
	caddr_t			raddr;	/* file server address */
	uint			ralen;	/* file server address length */
	fhandle_t		fh;	/* File handle to be mounted */
	int			flags;	/* flags */
	int			wsize;	/* write size in bytes */
	int			rsize;	/* read size in bytes */
	int			timeo;	/* initial timeout in .1 secs */
	int			retrans;	/* times to retry send */
	char			hostname[HOSTNAMESZ+1];	/* server name */
};

/*
 * NFS mount option flags
 */
#define	NFSMNT_SOFT	0x001		/* soft mount (hard is default) */
#define	NFSMNT_WSIZE	0x002		/* set write size */
#define	NFSMNT_RSIZE	0x004		/* set read size */
#define	NFSMNT_TIMEO	0x008		/* set initial timeout */
#define	NFSMNT_RETRANS	0x010		/* set number of request retrys */
#define	NFSMNT_HOSTNAME	0x020		/* set hostname for error printf */
