/*      @(#)nfs_clnt.h	3.1 LAI System V NFS Release 3.0/V3  source        */

/* #ident	@(#)nfs_clnt.h	35.1 */

/*
 * vfs pointer to mount info
 */
#define	vftomi(vfsp)	((struct mntinfo *)((vfsp)->m_bufp))

/*
 * vnode pointer to mount info
 */
#define	vtomi(vp)	((struct mntinfo *)(((vp)->i_mntdev)->m_bufp))

/*
 * NFS vnode to server's block size
 */
#define	vtoblksz(vp)	(vtomi(vp)->mi_bsize)


#define	HOSTNAMESZ	32

/*
 * NFS private data per mounted file system
 */
struct mntinfo {
	caddr_t		mi_addr;	/* server's address */
	uint		mi_addrlen;	/* size of server's address */
	uint		mi_hard : 1;	/* hard or soft mount */
	uint		mi_printed : 1;	/* not responding message printed */
	long		mi_tsize;	/* transfer size (bytes) */
	long		mi_stsize;	/* server's max transfer size (bytes) */
	long		mi_bsize;	/* server's disk block size */
	int		mi_mntno;	/* kludge to set client rdev for stat*/
	int		mi_timeo;	/* inital timeout in 10th sec */
	int		mi_retrans;	/* times to retry request */
	char		mi_hostname[HOSTNAMESZ];	/* server name */
};

/*
 * enum to specifiy cache flushing action when file data is stale
 */
enum staleflush	{NOFLUSH, SFLUSH};
