

/*****************************************************************************

	Rev = 1.1		Date of 'get'   = 09:15:42 1/6/89
				Date of 'delta' = 09:15:00 1/6/89

	File = f250addr.h

*****************************************************************************/


/**********************************************************************
 *								      *
 *		Copyright (c) Ferranti plc 1988			      *
 *								      *
 *	This is unpublished proprietory source code of Ferranti plc.  *
 *		The copyright of which vests in Ferranti plc.	      *
 **********************************************************************/


/**********************************************************************
 *								      *
 *	Structure used to hold details about each FVME250             *
 *	Used by device driver fvme250.c   			      *
 *								      *
 **********************************************************************/




struct me250addr {
	long	         *me250_mem;	/* Start of FVME250 address space     */
	struct brd_id    *me250_idblk;	/* Address of FVME250 id block        */
	short	         *me250_loc;	/* Address of FVME250 location monitor*/
	long	         *me250_queue;	/* Address to place request           */
	struct me250cmd  *cmd_buf;	/* Address cmd buffer in FVME250 space*/
	char	         *data_buf;	/* Address of data buffer             */
	char	         state;	       	/* State of FVME250                   */
	struct me250cmd  *cptrhead;     /* Address of first free cmd buffer   */
					/* in cmd pool of this FVME250        */
	int              next_cmdwait;  /* Set if driver is waiting for a     */
					/* command buffer to be released      */
	struct map       datamap[1000];  /* memory map used for data pool     */
	int              timeout_id;    /* id returned by last timeout()      */
};

