

/*****************************************************************************

	Rev = 1.1		Date of 'get'   = 09:15:43 1/6/89
				Date of 'delta' = 09:15:03 1/6/89

	File = f250error.h

*****************************************************************************/


/**********************************************************************
 *								      *
 *		Copyright (c) Ferranti plc 1988			      *
 *								      *
 *	This is unpublished proprietory source code of Ferranti plc.  *
 *		The copyright of which vests in Ferranti plc.	      *
 **********************************************************************/


/**********************************************************************
 *    							              *	
 *		Error codes returned from the FVME250 firmware        *
 *    							              *	
 **********************************************************************/



#define NOTAVAIL	0x01	/* Drive not available, off-line */
#define SEEKERR		0x02 	/* Disk seek error */
#define WRFAULT		0x03 	/* Write fault */
#define RDFAULT		0x04 	/* Read fault */
#define CRCERR		0x05	/* Cyclic redundancy error */
#define IDERR		0x06 	/* Identifier error */
#define TIMEOUT		0x07	/* Disk transfer timeout */
#define NOTAPE		0x08	/* No tape in drive */
#define EOT		0x09	/* Hit end of tape */
#define DATAERR		0x0a	/* Unrecoverable data error */
#define FILEMARK	0x0b	/* Hit a file mark */
#define ILLCOMMD	0x0c	/* Illegal ME250 command */
#define ILLCNTRL	0x0d	/* Illegal controller command */
#define BLANKTAPE	0x0e	/* No data found on tape */
#define BOT		0x0f	/* At the beginning of tape */
#define INVALPARAM	0x10	/* Invalid drive parameters */
#define DMA		0x11	/* DMA error */
#define SCSIERR		0x12	/* SCSI bus error */
#define POWRESET	0x13	/* Power on reset occurred on tape drive */
#define BADSCSINUM	0x14	/* Bad SCSI controller number */
#define BADDEVTYPE	0x15	/* Bad device type */
#define HEADERERR	0x16	/* Failed to read/write tape header */
#define INVALCONF	0x17	/* Invalid configuration */
#define SOFTBUG	        0x18	/* Software error */
#define DEVBUSY	        0x19	/* Device busy */
#define DEVERROR        0x1a	/* Device hardware error */
#define ILLLENGTH       0x1b	/* Incorrect block size */
