

/*****************************************************************************

	Rev = 1.1		Date of 'get'   = 09:15:44 1/6/89
				Date of 'delta' = 09:15:03 1/6/89

	File = f250fix.h

*****************************************************************************/


/**********************************************************************
 *								      *
 *		Copyright (c) Ferranti plc 1988			      *
 *								      *
 *	This is unpublished proprietory source code of Ferranti plc.  *
 *		The copyright of which vests in Ferranti plc.	      *
 **********************************************************************/


/**********************************************************************
 *								      *
 *	This file contains the declaration of the identification      *
 *	block of an FVME250.					      *
 *								      *
 **********************************************************************/


struct brd_id {
	char fill[4];
	char brd_id[4];		/* Board id check code LAmB */
	long stat_word;		/* Status Word */
	char brd_type[4];	/* Board type code, FIOP */
	long suppl;		/* Supplimentary info */
	long serial;		/* Board serial information */
	long rev;		/* Board firmware revision number */
	char flag[4];		/* WARM start flag */
	long monitor;		/* Address of location monitor */
	struct me250cmd * req;	/* Address of request */
	short clear_int;	/* Clear to interrupt softare driver */
	char reser1[24];	/* Reserved */ 
	char selftest[64];	/* Selftest results */
	char reser2[32];	/* Reserved */
};



#define BRDID	0x404		/* Board Id. Contains LAmB */
#define STAT	0x408		/* Status word */
#define BRDTYPE	0x40c		/* Board type, FIOP */
#define SUPPINFO	0x410	/* Supplimentary info. */
#define BRDSERIAL	0x414	/* Board serial number */
#define BRDREV	0x418		/* Board firmware revision  firmware */
#define WARM	0x41c		/* Warm start flag */
#define LOCADDR	0x1ffffe	/* Address of location monitor */
#define REQUEST 0x424		/* Address of request */
#define SOFTREADY 0x428		/* Software driver ready for interrupt */
#define SELFRESULTS	0x440	/* Selftest results */


#define TESTRUN		0x62aef000	/* Selftests are running */
#define TESTPASS	0x62ae0000	/* Selftest passed */
#define TESTFAIL	0x62ae7000	/* Selftest failed */
#define NODEVICE	0x62ae3000	/* failed to configure correctly */

#define LAMBSTR "LAmB"
#define IDLEN 4		/* Length of above string */

#define FIOPSTR  "FIOP" 
#define TYLEN 4		/* Length of above string */

	/* Because the ME250 cannot see the ME252 memory it is necessary 
	to have the commands and data buffers in the ME250 address space.
	Hence memory has to be reserved.
	*/
#define DATSTART 0x10a000	/* Start of data buffer in ME250 */
#define DATSIZE  0xf5ffe        /* Size of data buffer */

#define STARTPOOL 0x100000 	/* Start of command pool */
#define POOLSIZE  0xa000	/* Command pool size */
