

/*****************************************************************************

	Rev = 1.1		Date of 'get'   = 09:15:44 1/6/89
				Date of 'delta' = 09:15:04 1/6/89

	File = f250legal.h

*****************************************************************************/


/**********************************************************************
 *								      *
 *		Copyright (c) Ferranti plc 1988			      *
 *								      *
 *	This is unpublished proprietory source code of Ferranti plc.  *
 *		The copyright of which vests in Ferranti plc.	      *
 **********************************************************************/


/**********************************************************************
 *								      *
 *	Used to check legality of ioctl calls.			      *
 *	Used by device driver fvme250.c				      *
 *								      *
 **********************************************************************/


#define  L_SUSER  0x1      /*  legal for superuser ONLY    */
#define  L_STAPE  0x2      /*  legal on  streamer tape */
#define  L_FLOP   0x4      /*  legal on  floppies      */
#define  L_WINCH  0x8      /*  legal on  Winchesters   */

#define ME250CMDS 18

short legal[ME250CMDS+1] = {
/*  null command      */     0x0 ,		/*   illegal  */
/*  legal[READ_CMD]   */     0x0 ,              /*   illegal  */
/*  legal[WRITE_CMD]  */     0x0 , 		/*   illegal  */
/*  legal[FORMAT_CMD] */     0x4 ,              /*   floppy only  */
/*  legal[WRITEH_CMD] */     0x2 ,		/*   streamer only */
/*  legal[READH_CMD]  */     0x2 ,		/*   streamer only */
/*  legal[REWIND_CMD] */     0x2 ,		/*   streamer only */
/*  legal[WRFMKS_CMD] */     0x2 ,		/*   streamer only */
/*  legal[RETEN_CMD]  */     0x2 ,		/*   streamer only */
/*  legal[TEST_CMD]   */     0x0 ,        	/*   illegal  */
/*  legal[INIT_CMD]   */     0x0 ,       	/*   illegal  */
/*  legal[SPFMKS_CMD] */     0x2 ,              /*   streamer only  */
/*  legal[STPARAM_CMD]*/     0xf ,              /*   any device + super-user */
/*  legal[GTPARAM_CMD]*/     0xf ,              /*   any device + super-user */
/*  legal[COPY_CMD]   */     0xd ,              /*   floppy/winch +super-user */
/*  legal[RESTORE_CMD]*/     0xd ,              /*   floppy/winch +super-user */
/*  legal[SIZE_CMD]   */     0xe ,              /*   any device */
/*  legal[REASSIGN_CMD]*/    0xd ,              /*   floppy/winch +super-user */
};



