

/*****************************************************************************

	Rev = 1.1		Date of 'get'   = 09:15:44 1/6/89
				Date of 'delta' = 09:15:04 1/6/89

	File = f250slice.h

*****************************************************************************/


/**********************************************************************
 *								      *
 *		Copyright (c) Ferranti plc 1988			      *
 *								      *
 *	This is unpublished proprietory source code of Ferranti plc.  *
 *		The copyright of which vests in Ferranti plc.	      *
 **********************************************************************/


/**********************************************************************
 *								      *
 *        This file contains logical device information.	      *
 *								      *
 **********************************************************************/



struct me250slice 
{
     daddr_t nblocks;    /* Size of slice in sectors */
     daddr_t blkoff;     /* 1 st sector in slice */
};




struct confg             /* Configuration for each physical drive */
{
     short bytes_per_sector;       /* No. of bytes per sector            */
     short sectors_per_cyl;        /* No. of sectors per cylinder        */
     short dev_type;               /* type of device eg FLOPPY, STREAMER */
     short dev_name;               /* Device name eg WINC160M            */
     char  dev_cont;               /* Device controller                  */
     char  lun;                    /* Logical unit number                */
     struct me250slice slice[8];   /* Upto 8 partitions per device       */
};


#define AVAILABLE     1
#define UNAVAILABLE   0

struct device_info {
	char status;		   /* is device available                 */
	char option;		   /* details about options set on device */
	char openflag[8];	   /* is slice for this device open       */
};

/* The actual values for the information is in fvme250io.h  */

