/*
 *	Copyright (c) 1987 Motorola Inc
 *	All Rights Reserved
 *	@(#)gentape.h	35.1
 */

#ident	"@(#)gentape.h	35.1"

/*
 *	struct for the list of possible drivers to be used by
 *	the generic tape driver
 */

struct gentape {
	int *gt_addr;		/* device address */
	int *gt_bmaj;		/* block major number */
	int *gt_cmaj;		/* character major number */
	int gt_cpubrd;		/* cpu board where this device exists */
};

/*
 *	NOTAPE - constant known to be an illegal major number 
 */

#define	NOTAPE	-1

/*
 *	possible values for tape devices returned from the bootloader
 *	stored in the variable bootctlr
 */

#define BOOT350_00 0x04		/* MVME350 first controller */
#define BOOT350_10 0x05		/* MVME350 second controller */
#define BOOT147_00 0x0d		/* MVME147 first drive */
#define BOOT147_01 0x0e		/* MVME147 second drive */
#define BOOT327_00 0x15		/* MVME147 first controller first drive */
#define BOOT327_01 0x16		/* MVME147 first controller second drive */
#define BOOT327_10 0x1c		/* MVME147 second controller first drive */
#define BOOT327_11 0x1d		/* MVME147 second controller second drive */
