/* 
 * Line Discipline Switch Table with SXT and SCC support
 */

extern int nulldev(), nodev();
extern int ttopen(),ttclose(),ttread(),ttwrite(),ttioctl(),ttin(),ttout();

/*
 * SXT Support, line discipline 1. If not present table is 'padded'
 */
#ifdef SXT_0
extern int sxtin(),sxtout();
#else

/* these must be defined as dummys, as they are used in tty.c */
int sxtin() {};
int sxtout() {};

#endif

#ifdef	SCC_0
extern int sttread(), sttwrite(), sttin(), sttout();
#endif

/*
 * Table order: open close read write ioctl rxint txint modemint
 */
struct linesw linesw[] = {
	/* 
	 * Normal tty
	 */
	ttopen,
	ttclose,
	ttread,
	ttwrite,
	ttioctl,
	ttin,
	ttout,
	nulldev,
#ifdef SXT_0
	/* 
	 * Shell layers, sxt
	 */
	nulldev,
	nulldev,
	nulldev,
	nulldev,
	nulldev,
	sxtin,
	sxtout,
	nulldev,
#else
	/*
	 * No shell layers, pad table out so SCC does not move
	 */
	nodev,
	nodev,
	nodev,
	nodev,
	nodev,
	nodev,
	nodev,
	nodev,
#endif
#ifdef SCC_0
	/*
	 * SCC
	 */
	ttopen,
	ttclose,
	sttread,
	sttwrite,
	ttioctl,
	sttin,
	sttout,
	nulldev,
#endif
};

/*
 * Compute table size
 */
int linecnt = sizeof(linesw)/sizeof(struct linesw);

