/*
 *	Copyright (c) 1987 Motorola Inc
 *	All Rights Reserved
 *		@(#)mvme134.h	35.1
 */

/*
 *	Status and Control registers for the MVME134 CPU
 */

#define	V134_ROM	((char *)0x00000000)	/* Onboard ROM */
#define	V134_ROM2	((char *)0xfff00000)	/* Onboard ROM */
#define	V134_MFP	((ushort *)0xfff80000)	/* Base of Multi-function */
						/* peripheral (MK68901) chip */
#define	V134_CREG	((char *)0xfff80001)	/* GPIP register of MFP */

#define	V134_DCTS	0x0008			/* DCTS */
#define	V134_IE		0x0010			/* IE */
#define	V134_BRDFAIL	0x0020			/* Board Fail */

#define	V134_MSR	((ushort *)0xfff80000)	/* Module Stat (GPIP reg) */

#define	V134_SRBIT0	0x0100			/* J12 1-2 connected  */
#define	V134_SRBIT1	0x0200			/* J12 3-4 connected  */
#define	V134_SRBIT2	0x0400			/* J12 5-6 connected  */
#define	V134_SRBIT3	0x0800			/* J12 7-8 connected  */
#define	V134_SRBIT4	0x1000			/* J12 9-10 connected */
#define	V134_PWRUP	0x2000			/* Power up sets to 0 */
#define	V134_BE_SRC	0x2000			/* Bus Error source   */
						/* 0 = PMMU, 1 = 68020*/
#define	V134_SYSCON	0x4000			/* SYSCON = 1         */
#define	V134_ACFAIL	0x8000			/* ACFAIL = 1         */

#define	V134_BER_STAT	((ushort *)0xfff8000c)	/* MFP & STAT1 */

#define	V134_STAT1	((char *)0xfff8000d)	/* STAT1 - access as byte */

#define	V134_DDTR	0x0001			/* DDTR */
#define	V134_QVBERR	0x0002			/* VME bus error */
#define	V134_LTO	0x0004			/* local bus time out */
#define	V134_RMC	(V134_QVBERR|V134_LTO)	/* RMC lock = QVBERR + LTO */

#define	V134_STAT2	((char *)0xfff8000b)	/* STAT2 - access as byte */

#define	V134_OIRQ	0x0040			/* OIRQ */
#define	V134_SYSFAIL	0x0080			/* SYSFAIL */

#define	V134_SIO	((char *)0xfffa0000)	/* Base addr of SIO port */
#define	V134_RTC	((char *)0xfffc07f8)	/* Base addr of real time clk */
#define	V134_CLR_PMMU	((char *)0xfffd0000)	/* Addr to clear PMMU bus err */
#define	V134_VMEBUS2	((char *)0xfffe0000)	/* VMEbus */
#define	V134_VMEBUS_IO	((char *)0xffff0000)	/* VMEbus-global short I/O pg */
