/*
 *	Copyright (c) 1987 Motorola Inc
 *	All Rights Reserved
 *	@(#)mvme140.h	35.1
 */

/*
 *	Board Specific Defines for the MVME140 CPU
 */

/*
 *	Memory Map
 */

#define V140_TTY	((char *)0xffe02000)	/* DUART (d8) */
#define V140_CSR	((char *)0xffe00000)	/* CSR (d32) */
#define V140_ROM	((char *)0xffd00000)	/* ROM (d16) */
#define V140_HIRAM	((char *)0xffc00000)	/* Local RAM (256k d32) */
#define V140_LORAM	((char *)0x00000000)	/* Local RAM optional access */

/*
 *	Control Registers
 */

#define V140_VBI	0x80000000	/* VME Broadcast Interrupt = 0 */
#define V140_BERR	0x40000000	/* LTO or VMEbus error = 1     */
#define V140_ABORT	0x20000000	/* ABORT switch pressed        */
#define V140_S11	0x10000000	/* GP switch ON = 0 (S3-7)     */
#define V140_LTON	0x08000000	/* Local Timeout On = 0 (S3-8) */
#define V140_S01	0x02000000	/* GP switch ON = 0 (S4-1)     */
#define V140_S02	0x01000000	/* GP switch ON = 0 (S4-2)     */

#define V140_S03	0x00800000	/* GP switch ON = 0 (S4-3)     */
#define V140_S04	0x00400000	/* GP switch ON = 0 (S4-4)     */
#define V140_S05	0x00200000	/* GP switch ON = 0 (S4-5)     */
#define V140_S06	0x00100000	/* GP switch ON = 0 (S4-6)     */
#define V140_S07	0x00080000	/* GP switch ON = 0 (S4-7)     */
#define V140_S08	0x00040000	/* GP switch ON = 0 (S4-8)     */
#define V140_S09	0x00020000	/* GP switch ON = 0 (S4-9)     */
#define V140_S10	0x00010000	/* GP switch ON = 0 (S4-10)    */

#define V140_7VIM	0x00008000	/* VME Interrupt Mask Lvl 7 =1 */ 
#define V140_6VIM	0x00004000	/* VME Interrupt Mask Lvl 6 =1 */ 
#define V140_5VIM	0x00002000	/* VME Interrupt Mask Lvl 5 =1 */ 
#define V140_4VIM	0x00001000	/* VME Interrupt Mask Lvl 4 =1 */ 
#define V140_3VIM	0x00000800	/* VME Interrupt Mask Lvl 3 =1 */ 
#define V140_2VIM	0x00000400	/* VME Interrupt Mask Lvl 2 =1 */ 
#define V140_1VIM	0x00000200	/* VME Interrupt Mask Lvl 1 =1 */ 
#define V140_VBIM	0x00000100	/* VME Brdcst Int Mask =1      */ 

#define V140_GIM	0x00000080	/* Global Interrupt Mask =1    */ 
#define V140_SFM	0x00000040	/* Sysfail Interrupt Mask =1   */ 
#define V140_SFON	0x00000020	/* Sysfail ON =1               */ 
#define V140_RAM0	0x00000010	/* RAM access at addr 0  = 0   */ 
#define V140_VPCEN	0x00000008	/* VME Program Cache Enable =1 */
#define V140_VDCEN	0x00000004	/* VME Data Cache Enable =1    */
#define V140_VA32	0x00000002	/* VME 32 bit Address Mode =1  */
#define V140_VD32	0x00000001	/* VME 32 bit Data Mode =1     */

/*
 *	Other Constants
 */

#define V140_INIT_CSR	(0x8000015f)	/* See above */
