/*
 *	Copyright (c) 1987 Motorola Inc
 *	All Rights Reserved
 *	@(#)mvme143.h	35.1
 */

/*
 *	Status and Control registers for the MVME143 CPU
 */

#define	V143_STAT	((char *)0xfff9001b)	/* error status (PIT PSR) */

#define	V143_LTO	0x01		/* local bus time out */
#define	V143_QVBERR	0x02		/* VME bus error */
#define	V143_PARERR	0x08		/* Parity error */

#define	V143_STAT2	((char *)0xfff80001)	/* control/status (MFP GPIP) */

#define	V143nDRTS	0x01		/* Data Ready to Send */
#define	V143_SYSCON	0x02		/* System Controller */
#define	V143_PWRUP	0x04		/* Power Up */
#define	V143nDCTS	0x08		/* Data Clear to Send */
#define	V143nMIE	0x10		/* MPU Interrupt Enable */
#define	V143_BRDFAIL	0x20		/* Board Fail */
#define	V143_ACFAIL	0x40		/* AC Fail */
#define	V143_SYSFAIL	0x80		/* System Failure */

/* PIT PIVR (Programmable Interrupt Vector Register) */
/*
 * Programmable base for the following vectors:
 * 0 = LTOBERR
 * 1 = QVBERR
 * 2 = ABORT
 * 3 = PARERR
 */
#define V143_PIVR	((char *)0xfff9000b)	/* programmable (PIT PIVR) */

#define V143_PACR	((char *)0xfff9000d)	/* control/status (PIT PACR) */

#define V143_SUBMODE1X	0x80		/* Enable Submode 1x (bits 7-6)
#define V143_QV_ENB	0x04		/* QVBERR Interrupt Enable */
#define V143_LTO_ENB	0x02		/* LTOBERR Interrupt Enable */

#define V143_PBCR	((char *)0xfff9000f)	/* control/status (PIT PBCR) */

#define V143_PARENB	0x04		/* Parity Error Interrupt Enable */
#define V143_ABORT	0x02		/* Abort Interrupt Enable */

#define V143_PCDR	((char *)0xfff90019)	/* control/status (PIT PCDR) */

#define	V143nVPAREN	0x01		/* VMEbus Parity Enable */
#define	V143nPAREN	0x02		/* Parity Enable */
#define	V143nWWPAR	0x04		/* Write Wrong Parity Enable */
#define	V143nTEIRQ	0x08		/* PIT Timer Enable Interrupt Request */
#define	V143_GTOEN	0x10		/* Global Time Out Enable */
#define	V143nPIRQ	0x20		/* PIT Port Interrupt Request */
#define	V143nPIACK	0x40		/* PIT Port Interrupt Acknowledge */
#define	V143_LTOEN	0x80		/* Local Bus Timer Enable */

/* minimum number of repeated corrected errors
 * before display of message on system console device
 */
#define V143_MINCNT	15		/* Minimum count for parity errors */
