/*		Copyright (c) 1986,1987, 1988 Motorola		*/
/*		All Rights Reserved				*/
/*		@(#)mvme147s.h	35.2	*/
/*
 *	MVME147 SCSI definitions
 *
 *	Winchester Disk Descriptor Structure
 */

#define spl147 spl2

#define M147SEND(ep)	m147fwentry(ep);

#define MDSKMXCOAL	64		/* coalescing maximum number of entrys */
#define	M147PKTS	10		/* number of packets */
#define M147LIM		1		/* number of outstanding packets    */

#define	M147SBTS	4		/* number of bits to define slice   */
#define M147SLCS	(1<<M147SBTS)	/* number of slices on a disk	    */
#define M147BBIT	12		/* bit for mvme147b		   */


/* 
 * 	Default Drive Parameters for MVME147 SCSI Disk Drives
 */


#define FLOP	1
#define DISK	2
#define TAPE	3

	
/* 
 *		Tape Specific
 */

#define	ENVPERCHAN	10		/* envelopes per channel */

/* 
 * 	Default Drive Parameters for MVME147 SCSI Tape Drives
 */

/* t_phystracks -  number of tracks	*/
#define PTRACKS	5

/* t_logtracks -  number of tracks	*/
#define LTRACKS	5

/* t_extwrt -  extend on write flag */
#define EXTW	1
#define NOEXTW	0

/* t_byteswap -  byte swap mode flag */
#define BYTESWP 1
#define NOBYTESWP 0

/* t_buffmode -  buffered mode flag */
#define BUFMODE	1
#define NOBUFMODE	0

/* t_physbpb -  physical bytes per block */
#define PHYSBLK	0x200

/* t_logbpb -  logical bytes per block */
#define LOGBLK	0x200

/* t_qic -  QIC format		*/
#define QIC11	0x11
#define QIC24	0x24
#define QIC36	0x36
#define QIC120	0x120
#define QIC150	0x150

/* t_scount -  streaming count	*/
#define STRMCNT	10

/* t_retrycnt -  retry count */
#define RETRYCNT	10

/* t_minrd -  minimum read xfer	*/
#define MINRXSZ		1

/* t_minwrt -  minimum write xfer	*/
#define MINTXSZ		1


/* tape command control */
#define RETENSION 	0x02
#define SKEOD		0x03


