/*		Copyright (c) 1986,1987 Motorola		*/
/*		All Rights Reserved				*/
/*		@(#)mvme321.h	35.1					*/
/*
 *	Winchester Disk Descriptor Structure
 */

struct m321wdesc {
	unsigned char	w_valid;	/* valid flag			*/
	unsigned char	w_device;	/* logical device		*/
	unsigned char	w_drive;	/* drive number			*/
	unsigned char	w_retry;	/* retry count			*/
	unsigned char	w_rec_rtry;	/* recalibrate retry count	*/
	unsigned char	w_eccflag;	/* ECC correction use flag	*/
	unsigned char	w_crcecc;	/* CRC/ECC choice		*/
	unsigned char	w_step;		/* step rate			*/
	unsigned char	w_bsf;		/* buffered seek flag		*/
	unsigned char	w_initchr;	/* initialization character	*/
	unsigned char	w_brf;		/* buffered recalibrate flag	*/
	unsigned char	w_slips;	/* alt secs/trk	(secs to slip)	*/
	unsigned char	w_altcnt;	/* number of alternate tracks	*/
	unsigned char	w_psectrk;	/* physical sectors/track	*/
	unsigned char	w_trkcyl;	/* tracks/cylinder (heads)	*/
	unsigned char	w_sectrk;	/* logical sectors/track	*/
	ushort		w_cyls;		/* number of cylinders		*/
	ushort		w_redcyl;	/* reduced write current cyl	*/
	ushort		w_strcyl;	/* logical starting cylinder	*/
	ushort		w_endcyl;	/* logical ending cylinder	*/
	unsigned int	w_lblksz;	/* logical block size		*/
	ushort		w_filla;	/* reserved			*/
	ushort		w_fillb;	/* reserved			*/
	ushort		w_fillc;	/* reserved			*/
	ushort		w_filld;	/* reserved			*/
	ushort		w_secsiz;	/* sector size			*/
	unsigned char	w_gap1;		/* gap length 1			*/
	unsigned char	w_gap2;		/* gap length 2			*/
	unsigned char	w_gap3;		/* gap length 3			*/
	char		w_fill1;	/* reserved			*/
	ushort		w_fill2;	/* reserved			*/
	ushort		w_fill3;	/* reserved			*/
	ushort		w_fill4;	/* reserved			*/
	ushort		w_curcyl;	/* ????				*/
	unsigned char	w_sk_sts;	/* seek status			*/
	unsigned char	w_sk_flg;	/* seek flag			*/
	unsigned char	w_7261md;	/* uPD7261 mode			*/
	unsigned char	w_endtrk;	/* end track of cylinder	*/
	unsigned char	w_endsec;	/* ????				*/
	unsigned char	w_hdlen;	/* data bytes/sector, high byte	*/
	unsigned char	w_ldlen;	/* data bytes/sector, low byte	*/
	unsigned char	w_fill5;	/* reserved			*/
	unsigned int	w_lmaxtrk;	/* max logical track		*/
	unsigned int	w_lmaxsec;	/* max logical sector		*/
	ushort		w_presec;	/* sectors before start cyl	*/
	ushort		w_bytos;	/* bytes to sector shift number	*/
	ushort		w_stob;		/* sector to block shift number	*/
	unsigned int	w_maxsec;	/* max sector number		*/
	ushort		w_fill6;	/* reserved			*/
	ushort		w_fill7;	/* reserved			*/
	ushort		w_fill8;	/* reserved			*/
	ushort		w_fill9;	/* reserved			*/
};
	
/*
 *	Floppy Disk Descriptor Structure
 */

struct m321fdesc {
	unsigned char	f_device;	/* logical device		     */
	unsigned char	f_drive;	/* drive number			     */
	unsigned char	f_retry;	/* retry count			     */
	unsigned char	f_step;		/* stepping rate		     */
	unsigned char	f_dr_tpi;	/* tracks per inch of drive	     */
	unsigned char	f_med_tpi;	/* tracks per inch of media	     */
	unsigned char	f_sides;	/* single (1) or double (2) sided    */
	unsigned char	f_trkside;	/* tracks per side 		     */
	unsigned char	f_dens0;	/* density on side 0, track 0	     */
	unsigned char	f_sctr0;	/* sectors/track on side 0, track 0  */
	ushort		f_byte0;	/* bytes/sector on side 0, track 0   */
	unsigned char	f_dens;		/* single (1) or double (2) density  */
	unsigned char	f_sectrk;	/* sectors per track		     */
	ushort		f_secsiz;	/* bytes per sector		     */
	unsigned char	f_initchr;	/* initialization char for format    */
	unsigned char	f_format;	/* IBM (01) or Motorola (02) format  */
	unsigned char	f_precomp;	/* 1st track to precompensate writes */
	unsigned char	f_cache;	/* cache enable (2), disable (1)     */
	unsigned long	f_lblksz;	/* logical block size		     */
};	

/*	strategy initialization structure */
struct	m321strat {
	ushort		s_sfunc;	/* strategy function type	    */
	ushort		s_blk		/* blocking factor		    */
};

/*	cache initialization structure */
struct	m321cache {
	ushort		c_cn0;		/* drive 0 cache number		    */
	ushort		c_cn1;		/* drive 1 cache number		    */
	ushort		c_cn2;		/* drive 2 cache number		    */
	ushort		c_cn3;		/* drive 3 cache number		    */
	ushort		c_ce0;		/* cache 0 entries		    */
	ushort		c_ce1;		/* cache 1 entries		    */
	ushort		c_ce2;		/* cache 2 entries		    */
	ushort		c_ce3;		/* cache 3 entries		    */
	ushort		c_cbs0;		/* cache 0 buffer size		    */
	ushort		c_cbs1;		/* cache 1 buffer size		    */
	ushort		c_cbs2;		/* cache 2 buffer size		    */
	ushort		c_cbs3;		/* cache 3 buffer size		    */
};

#define	M321PKTS	200		/* number of packets per controller */
#define M321LIM0	2		/* packet limit before open of wini */
#define M321LIM1	M321PKTS*7/8	/* packet limit for 1 winchester    */
#define M321LIM2	M321PKTS*6/8	/* packet limit for 2 winchester    */
#define M321LIM3	M321PKTS*5/8	/* packet limit for 3 winchester    */
#define M321LIM4	M321PKTS*4/8	/* packet limit for 4 winchester    */

#define	FLOP_LIM	2		/* floppy packet limit		    */

#define	M321SBTS	4		/* number of bits to define slice   */
#define M321SLCS	(1<<M321SBTS)	/* number of slices on a disk	    */

/*	Command Access Address Modifier */
#define	DATA24	0x3d			/* 24-bit data			    */
#define	DATA32	0x0d			/* 32-bit data			    */
