/*		Copyright (c) 1986,1987,1988 Motorola,Inc	*/
/*		All Rights Reserved				*/
/*		@(#)mvme327.h	35.4 */
/*
 *	Winchester Disk Descriptor Structure
 */


#define	M327PKTS	100		/* number of packets */

#define M327LIM		1		/* number of outstanding packets    */
					/* THIS MUST be 1 with coalescing   */

#define	M327SBTS	4		/* number of bits to define slice   */
#define M327SLCS	(1<<M327SBTS)	/* number of slices on a disk	    */
#define M327BBIT	12		/* bit for mvme327b		    */
#define M327NREGS	12		/* number of registers to log on error*/


/*	Command Access Address Modifier */
#define	DATA24	0x3d			/* 24-bit data			    */
#define	DATA32	0x0d			/* 32-bit data			    */

/*	Bus width	*/

#define BUSW	0x2

/*	struct b_packet overlays 	*/
#define p_327badtype	p_cparm1	/* bad spot count		   */
#define p_327badcnt	p_cparm2	/* bad track			   */

/* 
 * 	Default Drive Parameters for MVME327 SCSI Disk Drives
 */

#define M327FLOP	0x01
#define M327DISK	0x02
#define M327TAPE	0x05

#define EMPTY 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

#define DISKDEVICE 0,M327DISK,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

	
#define CDCWRENIII 	0x10,	/* controller type	*/\
			M327DISK,/* peripheral type	*/\
			9,	/* number of heads	*/\
			0,	/* fixed or removeable	*/\
			967,	/* number of cylinders	*/\
			512,	/* bytes per sector	*/\
			512,	/* logical block size	*/\
			35,	/* sectors per track	*/\
			1,	/* reserved sects/track */\
			0,	/* hard/soft sector flag*/\
			0,	/* interleave factor	*/\
			0x4e,	/* format init char	*/\
			27,	/* retry count		*/\
			0,	/* step rate		*/\
			0,	/* floppy format	*/\
			0,	/* pre-compensation cyl	*/\
			0,	/* reduced write cyl	*/\
			0,	/* type of alternates	*/\
			16,	/* number of alternates */\
			1,	/* ECC flag		*/\
			0,	/* spiral offset	*/\
			0,	/* gap1 size		*/\
			0,	/* gap2 size		*/\
			0,	/* gap3 size		*/\
			0,	/* gap4 size		*/\
			0,	/* disk strategy select	*/\
			0,	/* disk blocking factor	*/\
			0,	/* cylinder skew	*/\
			0	/* cache entry size	*/

#define CDCWRENIV 	0x13,	/* controller type	*/\
			M327DISK,/* peripheral type	*/\
			9, 	/* number of heads	*/\
			0,	/* fixed or removeable	*/\
			0x584,	/* number of cylinders	*/\
			512,	/* bytes per sector	*/\
			512,	/* logical block size	*/\
			0x2e,	/* sectors per track	*/\
			1,	/* reserved sects/track */\
			0,	/* hard/soft sector flag*/\
			0,	/* interleave factor	*/\
			0x4e,	/* format init char	*/\
			27,	/* retry count		*/\
			0,	/* step rate		*/\
			0,	/* floppy format	*/\
			0,	/* pre-compensation cyl	*/\
			0,	/* reduced write cyl	*/\
			0,	/* type of alternates	*/\
			16,	/* number of alternates */\
			1,	/* ECC flag		*/\
			0,	/* spiral offset	*/\
			0,	/* gap1 size		*/\
			0,	/* gap2 size		*/\
			0,	/* gap3 size		*/\
			0,	/* gap4 size		*/\
			0,	/* disk strategy select	*/\
			0,	/* disk blocking factor	*/\
			0,	/* cylinder skew	*/\
			1	/* cache entry size	*/

#define MAXTOR4380 	0x0f,	/* controller type	*/\
			M327DISK,/* peripheral type	*/\
			15, 	/* number of heads	*/\
			0,	/* fixed or removeable	*/\
			1224,	/* number of cylinders	*/\
			512,	/* bytes per sector	*/\
			512,	/* logical block size	*/\
			35,	/* sectors per track	*/\
			1,	/* reserved sects/track */\
			0,	/* hard/soft sector flag*/\
			1,	/* interleave factor	*/\
			0x4e,	/* format init char	*/\
			10,	/* retry count		*/\
			0,	/* step rate		*/\
			0,	/* floppy format	*/\
			0,	/* pre-compensation cyl	*/\
			0,	/* reduced write cyl	*/\
			0,	/* type of alternates	*/\
			16,	/* number of alternates */\
			1,	/* ECC flag		*/\
			0,	/* spiral offset	*/\
			0,	/* gap1 size		*/\
			0,	/* gap2 size		*/\
			0,	/* gap3 size		*/\
			0,	/* gap4 size		*/\
			0,	/* disk strategy select	*/\
			0,	/* disk blocking factor	*/\
			0,	/* cylinder skew	*/\
			0	/* cache entry size	*/


#define MICRO1375 	0x11,	/* controller type	*/\
			M327DISK,/* peripheral type	*/\
			8, 	/* number of heads	*/\
			0,	/* fixed or removeable	*/\
			1024,	/* number of cylinders	*/\
			512,	/* bytes per sector	*/\
			512,	/* logical block size	*/\
			36,	/* sectors per track	*/\
			1,	/* reserved sects/track */\
			0,	/* hard/soft sector flag*/\
			0,	/* interleave factor	*/\
			0x4e,	/* format init char	*/\
			10,	/* retry count		*/\
			0,	/* step rate		*/\
			0,	/* floppy format	*/\
			0,	/* pre-compensation cyl	*/\
			0,	/* reduced write cyl	*/\
			0,	/* type of alternates	*/\
			16,	/* number of alternates */\
			1,	/* ECC flag		*/\
			0,	/* spiral offset	*/\
			0,	/* gap1 size		*/\
			0,	/* gap2 size		*/\
			0,	/* gap3 size		*/\
			0,	/* gap4 size		*/\
			0,	/* disk strategy select	*/\
			0,	/* disk blocking factor	*/\
			0,	/* cylinder skew	*/\
			0	/* cache entry size	*/

#define MINI40 		0x14,	/* controller type	*/\
			M327DISK,/* peripheral type	*/\
			4, 	/* number of heads	*/\
			0,	/* fixed or removeable	*/\
			739,	/* number of cylinders	*/\
			512,	/* bytes per sector	*/\
			512,	/* logical block size	*/\
			28,	/* sectors per track	*/\
			1,	/* reserved sects/track */\
			0,	/* hard/soft sector flag*/\
			1,	/* interleave factor	*/\
			0x4e,	/* format init char	*/\
			10,	/* retry count		*/\
			0,	/* step rate		*/\
			0,	/* floppy format	*/\
			0,	/* pre-compensation cyl	*/\
			0,	/* reduced write cyl	*/\
			0x11,	/* type of alternates	*/\
			1,	/* number of alternates */\
			1,	/* ECC flag		*/\
			0,	/* spiral offset	*/\
			0,	/* gap1 size		*/\
			0,	/* gap2 size		*/\
			0,	/* gap3 size		*/\
			0,	/* gap4 size		*/\
			0,	/* disk strategy select	*/\
			0,	/* disk blocking factor	*/\
			0,	/* cylinder skew	*/\
			0	/* cache entry size	*/

#define SEAGATE40 	0x14,	/* controller type	*/\
			M327DISK,/* peripheral type	*/\
			6, 	/* number of heads	*/\
			0,	/* fixed or removeable	*/\
			613,	/* number of cylinders	*/\
			512,	/* bytes per sector	*/\
			512,	/* logical block size	*/\
			0x1a,	/* sectors per track	*/\
			1,	/* reserved sects/track */\
			0,	/* hard/soft sector flag*/\
			1,	/* interleave factor	*/\
			0x4e,	/* format init char	*/\
			10,	/* retry count		*/\
			0,	/* step rate		*/\
			0,	/* floppy format	*/\
			0,	/* pre-compensation cyl	*/\
			0,	/* reduced write cyl	*/\
			0,	/* type of alternates	*/\
			16,	/* number of alternates */\
			1,	/* ECC flag		*/\
			0,	/* spiral offset	*/\
			0,	/* gap1 size		*/\
			0,	/* gap2 size		*/\
			0,	/* gap3 size		*/\
			0,	/* gap4 size		*/\
			0,	/* disk strategy select	*/\
			0,	/* disk blocking factor	*/\
			0,	/* cylinder skew	*/\
			0	/* cache entry size	*/
	
#define SEAGATE80 	0x14,	/* controller type	*/\
			M327DISK,/* peripheral type	*/\
			6, 	/* number of heads	*/\
			0,	/* fixed or removeable	*/\
			0x331,	/* number of cylinders	*/\
			512,	/* bytes per sector	*/\
			512,	/* logical block size	*/\
			0x22,	/* sectors per track	*/\
			1,	/* reserved sects/track */\
			0,	/* hard/soft sector flag*/\
			1,	/* interleave factor	*/\
			0x4e,	/* format init char	*/\
			10,	/* retry count		*/\
			0,	/* step rate		*/\
			0,	/* floppy format	*/\
			0,	/* pre-compensation cyl	*/\
			0,	/* reduced write cyl	*/\
			0x11,	/* type of alternates	*/\
			0,	/* number of alternates */\
			1,	/* ECC flag		*/\
			0,	/* spiral offset	*/\
			0,	/* gap1 size		*/\
			0,	/* gap2 size		*/\
			0,	/* gap3 size		*/\
			0,	/* gap4 size		*/\
			0,	/* disk strategy select	*/\
			0,	/* disk blocking factor	*/\
			0,	/* cylinder skew	*/\
			0	/* cache entry size	*/

/*	double sided double density local floppy	*/
#define DSDDFLOP 	0x0,	/* controller type	*/\
			M327FLOP,/* peripheral type	*/\
			2, 	/* number of heads	*/\
			1,	/* fixed or removeable	*/\
			80,	/* number of cylinders	*/\
			256,	/* bytes per sector	*/\
			512,	/* logical block size	*/\
			16,	/* sectors per track	*/\
			0,	/* reserved sects/track */\
			0,	/* hard/soft sector flag*/\
			0,	/* interleave factor	*/\
			0x4e,	/* format init char	*/\
			3,	/* retry count		*/\
			20,	/* step rate		*/\
			0x0d,	/* floppy format	*/\
			2,	/* pre-compensation cyl	*/\
			0,	/* reduced write cyl	*/\
			0,	/* type of alternates	*/\
			0,	/* number of alternates */\
			1,	/* ECC flag		*/\
			0,	/* spiral offset	*/\
			0,	/* gap1 size		*/\
			0,	/* gap2 size		*/\
			0,	/* gap3 size		*/\
			0,	/* gap4 size		*/\
			0,	/* disk strategy select	*/\
			0,	/* disk blocking factor	*/\
			0,	/* cylinder skew	*/\
			0	/* cache entry size	*/

/*	IBM PC/AT high speed local floppy		*/
#define PCATFLOP 	0x0,	/* controller type	*/\
			M327FLOP,/* peripheral type	*/\
			2, 	/* number of heads	*/\
			1,	/* fixed or removeable	*/\
			80,	/* number of cylinders	*/\
			512,	/* bytes per sector	*/\
			512,	/* logical block size	*/\
			15,	/* sectors per track	*/\
			0,	/* reserved sects/track */\
			0,	/* hard/soft sector flag*/\
			0,	/* interleave factor	*/\
			0x4e,	/* format init char	*/\
			3,	/* retry count		*/\
			20,	/* step rate		*/\
			0x1f,	/* floppy format	*/\
			0,	/* pre-compensation cyl	*/\
			0,	/* reduced write cyl	*/\
			0,	/* type of alternates	*/\
			0,	/* number of alternates */\
			1,	/* ECC flag		*/\
			0,	/* spiral offset	*/\
			0,	/* gap1 size		*/\
			0,	/* gap2 size		*/\
			0,	/* gap3 size		*/\
			0,	/* gap4 size		*/\
			0,	/* disk strategy select	*/\
			0,	/* disk blocking factor	*/\
			0,	/* cylinder skew	*/\
			0	/* cache entry size	*/

/* 
 *		Tape Specific
 */


/* 
 * 	Default Drive Parameters for MVME327 SCSI Tape Drives
 */

/* t_phystracks -  number of tracks	*/
#define PTRACKS	5

/* t_logtracks -  number of tracks	*/
#define LTRACKS	5

/* t_extwrt -  extend on write flag */
#define EXTW	1
#define NOEXTW	0

/* t_byteswap -  byte swap mode flag */
#define BYTESWP 1
#define NOBYTESWP 0

/* t_buffmode -  buffered mode flag */
#define BUFMODE	1
#define NOBUFMODE	0

/* t_physbpb -  physical bytes per block */
#define PHYSBLK	0x200

/* t_logbpb -  logical bytes per block */
#define LOGBLK	0x200

/* t_qic -  QIC format		*/
#define QIC11	0x11
#define QIC24	0x24
#define QIC36	0x36
#define QIC120	0x120
#define QIC150	0x150

/* t_scount -  streaming count	*/
#define STRMCNT	10

/* t_retrycnt -  retry count */
#define RETRYCNT	10

/* t_minrd -  minimum read xfer	*/
#define MINRXSZ		1

/* t_minwrt -  minimum write xfer	*/
#define MINTXSZ		1


/* tape command control */
#define RETENSION 	0x02
#define SKEOD		0x03	/* seek to end-of-data */
#define SKNEXT		0x01	/* seek to next file */


#define ARCHIVE		0x12,	/* controller type		*/\
			M327TAPE,/* drive type			*/\
			5,	/* number of physical tracks	*/\
			5,	/* number of logical tracks	*/\
			0,	/* extend on write flag		*/\
			0,	/* byte swap mode flag 		*/\
			1,	/* buffered mode flag  		*/\
			0,	/* reserved 			*/\
			0x200,	/* physical bytes per block	*/\
			0x200,	/* logical bytes per block 	*/\
			0x120,	/* QIC format			*/\
			10,	/* streaming count		*/\
			0,	/* reserved			*/\
			10,	/* retry count			*/\
			1,	/* minimum read xfer		*/\
			1,	/* minimum write xfer		*/\
			0,	/* reserved			*/\
			0,	/* reserved			*/\
			0,	/* reserved			*/\
			0,	/* reserved			*/\
			0,	/* reserved			*/\
			0,	/* reserved			*/\
			0	/* reserved			*/

