/*		Copyright (c) 1987 Motorola			*/
/*		All Rights Reserved				*/
/*		@(#)mvme336c.h	35.1		*/
/*
 */
/*
	mvme336c.h - common include file to xpc and sio

/* 
	This is an indication that the sio should be
	brought to this condition
*/

#define STARTUP 1
#define SHUTDOWN 2


/*
	This is the condition that the sio/xpc is in
*/
#define ALIVE 1
#define DEAD 2



#define MAX_XTX_DATA	0x44	/* the size of a transmit data packet */
#define MAX_XRX_DATA	0x200	/* the size of a receive data packet */

struct port_data 
{
	UCHAR type:4;
	UCHAR port:4;
	UCHAR data;
};

struct rx_packet
{
	struct rx_packet *next;
	struct port_data data[MAX_XRX_DATA];


};

struct tx_hdr
{
        UCHAR port_no;
        UCHAR function;
        UCHAR packet_id;
        UCHAR count;
};


struct xmit_packet
{
	struct tx_hdr tx_hdr;
        UCHAR data[MAX_XTX_DATA];
};



struct xmit_pkt
{
	UCHAR device;
	UCHAR flag;
	UINT count;
	struct xmit_pkt *next;
	UCHAR txp[MAX_XTX_DATA];
};

