/*@(#)mvme374.h	35.1*/

/*IH*********************** INCLUDE HEADER ****************************
**
**  INCLUDE NAME:	mvme374.h
**
**  DESCRIPTION:	This file contains all MVME374 NVRAM specific
**			defines.
**
**  NOTES: (1) There is a nibble at the end of each parameter value that
**	   is a checksum for the value.  There is also a nybble at the 
**	   end of NVRAM that is a checksum for all of NVRAM.
**
**	   (2) Beginning at nibble 246 of NVRAM, we have 1 byte for the
**	   factory test value and 1 nybble for its checksum.
**
**  UPDATE LOG:
**  Date	Name		V/R	Comments
**  --------	-----------	---	-----------------------------
**  07/20/87	R. Robinson  	1.1	Original coding.
**
**********************************************************************/

/*
**  NVRAM index values for parameter storage.  The index relates to a 
**  nibble index, not a byte index.  There is always a single nibble
**  checksum value that follows any parameter. Sizes are given in bytes
**  (not nibbles).
**
**  NOTE: The next free index value is 33.
*/

#define	BASE_ADDR_INDEX		0	/* 1 byte VME base address for board */
#define	BASE_ADDR_SIZE		1	/* 1 byte VME base address for board */
#define	TS_ADDR_INDEX		3	/* 6 bytes this station address	     */
#define	TS_ADDR_SIZE		6	/* 6 bytes this station address	     */
#define	GA_MASK_INDEX		16	/* 8 bytes group address mask        */
#define	GA_MASK_SIZE		8	/* 8 bytes group address mask        */

/*
**  Field Indicator Values
*/

#define  BASE_ADDR		0
#define  TS_ADDR		1
#define  GA_MASK		2
