/*@(#)bdb.h	35.2*/
/*IH*********************** INCLUDE HEADER ****************************
**
**  INCLUDE NAME:	bdb.h
**
**  DESCRIPTION:	This file contains the descriptions for buffer
**			descriptor blocks.  Buffer descriptor blocks
**			are the header information for an individual
**			frame.  The frame itself is conceptually a
**			separate structure, and the bdb includes a
**			pointer to the frame.
**
**  NOTES:
**
**  UPDATE LOG:
**  Date	Name		V/R	Comments
**  --------	-----------	---	-----------------------------
**  07/10/85	Roy Larsen	1.0	Original submital to SCCS
**  01/13/86	Roy Larsen	1.0	Made BDB conform to TBC BDB
**
**********************************************************************/

/*
**  Define size of protocol data unit. (Frame buffers.)
*/

#define	PDU_SIZE	1518	/* Size of protocol data units.	     */
#define	HEAD_ROOM	50	/* Total size of headers in pdu.     */
#define	MAX_DATA_SIZE	(PDU_SIZE - HEAD_ROOM) /* Data buffer size.  */

/*
**  Declare buffer descriptor blocks.
*/

typedef	struct	bdb
{
	USHORT	fcodes;		/* Address control bits.	     */
	UBYTE  *data;		/* Pointer to data buffer.	     */
	USHORT	buff_offset;	/* Offset to first valid byte.	     */
	USHORT	buff_length;	/* Length of data actually used.     */
	USHORT	buff_unused;	/* length of data not used	     */
	USHORT	next_fcodes;	/* Next bdb address control bits.    */
struct	bdb    *next_bdb;	/* Pointer to next bdb if linked.    */
	USHORT	buff_size;	/* Total data buffer size in bytes.  */
	DEFAULT	pid;		/* EPB partition id.		     */
	ULONG	reserved;	/* reserved for future use	     */
	UBYTE	dummy[PDU_SIZE];/* Data referenced through "*data".  */
} BDB;
