/*	Copyright (c) 1988 MOTOROLA */
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOTOROLA	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

#ident	"@(#)sock_var.h	35.1"

#define MAX_SEQ		5		/* max backlog			*/
#define NSOCK		64		/* # of sockets we provide	*/
/*
 * our socket structure.
 */
struct sock {
	ushort	state;			/* socket state			*/
	ushort	flags;			/* flags			*/
	ushort	error;			/* current error		*/
	ushort	pgrp;			/* current process group	*/
	ushort  mark;			/* `mark' for OOB data		*/
	ushort  options;		/* socket level options		*/
	ushort	linger;			/* linger time if data present	*/
	inode_t *inode;			/* ^ to inode			*/
	struct sck_proto *proto;	/* ^ to protocol		*/
	struct sockaddr src;		/* bound address		*/
	struct sockaddr dst;		/* connect address		*/
	mblk_t *conex;			/* incoming connects		*/
	mblk_t *input;			/* reassembly q for T_DATA	*/
	mblk_t *einput;			/* reassembly q for T_EXDATA	*/
};

/*
 * socket states
 */
#define SO_ING			0x0001		/* socket tense		*/
#define	SO_OPEN			0x0002
#define SO_BOUND		0x0004
#define SO_UNBOUND		0x0008
#define SO_CONNECTED		0x0010
#define SO_ACCEPTED		0x0020
#define SO_DISCONNECTED		0x0040
#define	SO_LISTEN		0x0080
#define SO_SHUTDOWN		0x0100
#define SO_OPTSET		0x0200
#define SO_FATAL		0x8000	/* fatal error on socket */

#define SO_CONNECTING		(SO_CONNECTED		| SO_ING)
#define SO_BINDING		(SO_BOUND		| SO_ING)
#define SO_ACCEPTING		(SO_ACCEPTED		| SO_ING)
#define SO_DISCONNECTING	(SO_DISCONNECTED	| SO_ING)
#define SO_SHUTDOWNING		(SO_SHUTDOWN		| SO_ING)
#define SO_UNBINDING		(SO_UNBOUND		| SO_ING)
#define SO_OPTSETTING		(SO_OPTSET		| SO_ING)
/*
 * socket flags
 */
#define SF_BUSY		0x0001		/* socket is busy		*/
#define SF_WAKEUP	0x0002		/* sleeper requests wakeup	*/
#define SF_EXPROC	0x0010		/* processing expedited data	*/
#define SF_EXPEND	0x0020		/* expedited data pending	*/
#define SF_EXFLAGS	0x0030		/* EXPROC | EXPEND		*/
#define SF_NONBLOCKING	0x0040		/* O_NDELAY set			*/
#define SF_NORECV	0x0100		/* no more receives		*/
#define SF_NOSEND	0x0200		/* no more sends		*/
#define SF_SEEN_ORDREL	0x0400		/* seen T_ORDREL_IND		*/

/*
 * socket communication domains.
 * We currently only support the AF_INET domain, whose services are
 * provided by TLImux.
 */
struct domain {
	char *name;			/* name of the domain	*/
	short af;			/* addressing format	*/
	short addrsiz;			/* size of address	*/
	struct sck_proto *proto;	/* ^ to the protocols	*/
};

/*
 * protocol descriptions
 */
struct sck_proto {
	char *name;		/* name for debug			*/
	char type;		/* socket type for this protocol	*/
	char proto;		/* protocol number			*/
	char flags;		/* protocol flags			*/
	dev_t dev;		/* maj,min device to open		*/
	struct domain *domain;	/* ^ back to the domain			*/
};
/*
 * protocol flags
 */
#define PRF_CONN_REQUIRED	0x0001	/* connection oriented protocol	*/
#define PRF_ATOMIC		0x0002	/* atomic read/write		*/
/*
 * misc
 */
#define READ		1
#define WRITE		2
/*
 * We used the i_rcvd field of the inode to record the ^ to the socket.
 * This (in addition to other considerations) means that sockets cannot
 * be used as mount points for the RFS
 */
#define q_to_sck(q)	((struct sock *) q_to_shd(q)->sd_inode->i_sck)
#define q_to_shd(q)	((struct stdata *) (q)->q_ptr)	/* q to stream head */
