/*	Copyright (c) 1988 MOTOROLA */
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOTOROLA	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

#ident	"@(#)socket.h	35.1"

/*
 * socket -	definitions pertaining to the socket interface
 *
 * The socket interface is built on top of streams based TPI providers.
 * It has an incestuous relationship with the normal stream head routines.
 */

/*
 * since sockets are streams inodes, their file type is character special.
 * we use a flag to distinguish sockets.
 */
#define	ISOCKET	0x4000		/* this is a socket inode	*/
#define is_socket(ip)		((ip)->i_flag & ISOCKET)

/*
 * socket options
 */
#define SO_DEBUG		0x0001		/* socket debugging	*/
#define SO_REUSEADDR		0x0002		/* reuse address	*/
#define SO_KEEPALIVE		0x0004		/* keep connexion alive	*/
#define SO_DONTROUTE		0x0008		/* don't route		*/
#define SO_LINGER		0x0010		/* linger on close	*/

/*
 * socket address families
 */
#define AF_UNSPEC		0		/* unspecified		*/
#define AF_UNIX			1		/* not supported	*/
#define AF_INET			2		/* internet		*/
#define AF_IMPLINK		3		/* not supported	*/
#define AF_PUP			4		/* not supported	*/

/*
 * socket types
 */
#define SOCK_STREAM		1		/* stream		  */
#define SOCK_DGRAM		2		/* datagramme		  */
#define SOCK_RAW		3		/* raw socket		  */
#define SOCK_SEQPACKET		4		/* sequenced packet	  */
#define SOCK_RDM		5		/* reliably delivered msg */

/*
 * generalised socket addresses
 */
struct sockaddr {
	short sa_family;		/* address family		*/
	char  sa_data[14];		/* up to 14 bytes of address	*/
};

/*
 * socket ioctls
 */
#define SIOCSPGRP	((('S' << 8) | 'O') << 8) | 1
#define SIOCGPGRP	((('S' << 8) | 'O') << 8) | 2
#define SIOCATMARK	((('S' << 8) | 'O') << 8) | 3

/*
 * socket options
 */
#define SOL_SOCKET	1		/* options for socket level	*/

/*
 * Maximum queue length specifiable by listen.
 */
#define	SOMAXCONN	5

/*
 * misc
 */
#define	MSG_OOB		0x1		/* process out-of-band data	*/
#define	MSG_PEEK	0x2		/* peek at incoming message	*/
#define	MSG_DONTROUTE	0x4		/* not supported		*/
