/*
 *	Copyright (c) 1984 AT&T
 *	Copyright (c) 1987 Motorola Inc
 *	All Rights Reserved
 *	@(#)space.h	35.15
 */

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

/*	Added code for generic tape driver to be able to handle FVME250 */
/*	Author: M. Woods	Date: 31/1/89				*/

#ident	"@(#)space.h	35.15"

#define	KERNEL 1

#include "sys/tty.h"
struct	cblock	cfree[NCLIST];	/* free list for character block */
unsigned int	consdev;	/* major and minor device number of console */
unsigned int	dualcons;	/* major and minor device number of alternate
				   console */

#include "sys/buf.h"
char         *bufferz;		/* pointer to buffer pages */
struct buf   *bufz;             /* pointer to buffer headers */
struct buf   *pbufz;            /* pointer to physical buffer headers */

struct	hbuf	*hbufz;		/* buffer hash table pointer */

#include "sys/file.h"
struct	file	file[NFILE];	/* file table */

#include	"sys/inode.h"
#include	"sys/fs/s5inode.h"
struct	inode	inode[NINODE];	/* inode table */
struct	s5inode	s5inode[NS5INODE];

#include "sys/immu.h"
#include "sys/region.h"
#include "sys/proc.h"
struct	proc	proc[NPROC];	/* process table */

reg_t region[NREGION];

#include "sys/getpages.h"
pglst_t	spglst[MAXSWAPLIST];	/* page swap list */
gprgl_t	gprglst[MAXSWAPLIST];	/* region lock list */

#include "sys/map.h"
struct map sptmap[SPTMAP];

#include "sys/smpgmap.h"
struct smpgmap smpgmap[SMPGMAPSZ];

char putbuf[PUTBUFSZ];
int putbufsz = {PUTBUFSZ};

#include "sys/callo.h"
struct callo callout[NCALL];	/* Callout table */

#include "sys/mount.h"
struct mount mount[NMOUNT];	/* Mount table */

#include "sys/elog.h"
#include "sys/err.h"
struct	err	err = {		/* Error slots */
	NESLOT,
};

#include "sys/sysinfo.h"
struct sysinfo sysinfo;
struct syswait syswait;
struct syserr syserr;

struct	shlbinfo shlbinfo
	= {SHLBMAX, 0, 0};

#include "sys/utsname.h"

#ifndef	SYS
#define	SYS	"sysV68"
#endif

#ifndef	NODE
#define	NODE	"sysV68"
#endif

#ifndef	REL
#define	REL	"V/68.3"
#endif

#ifndef	VERSION
#define VERSION	"0"
#endif

#ifndef	MACHINE
#define	MACHINE	"M68020"
#endif

struct	utsname utsname = {
	SYS,
	NODE,
	REL,
	VERSION,
	MACHINE
};

#include "sys/var.h"
struct var v = {
	NBUF,
	NCALL,
	NINODE,
	(char *)(&inode[NINODE]),
	NFILE,
	(char *)(&file[NFILE]),
	NMOUNT,
	(char *)(&mount[NMOUNT]),
	NPROC,
	(char *)(&proc[NPROC]),
	NREGION,
	NCLIST,
	MAXUP,
	NHBUF,
	NHBUF-1,
	NPBUF,
	SPTMAP,
	VHNDFRAC,
	0,/* v_maxpmem */
	NAUTOUP,
	NOFILES,
	NQUEUE,
	NSTREAM,
	NBLK32768,
	NBLK16384,
	NBLK8192,
	NBLK4096,
	NBLK2048,
	NBLK1024,
	NBLK512,
	NBLK256,
	NBLK128,
	NBLK64,
	NBLK16,
	NBLK4,
	NS5INODE,
	MAXSWAPLIST,
	SMPGMAPSZ
};

int	synctime = TODCSYNC;
int	slice_size = MAXSLICE;
int	cdlimit = CDLIMIT;
int	textro = TEXTRO;
#include "sys/mvmecpu.h"
int	cpuboard = CPUBOARD;		/* cpu board type */
short	transparent = TRANSPARENT;	/* enable transparent translation */
short	a45j = A45J;			/* fix bad 68020 mask a45j */
short	a99a = A99A;			/* fix bad 68851 mask a99a */
short	waitrmc = WAITRMC;		/* Wait for VMEbus on RMC cycles */

#include "sys/tuneable.h"
tune_t tune = {
	GPGSLO,
	GPGSHI,
	GPGSMSK,
	VHANDR,
	0,
	MAXUMEM,
	BDFLUSHR,
	MINARMEM,
	MINASMEM,
	MAXRDAHEAD
};

#include "sys/init.h"

/*
#ifndef	PRF_0
prfintr() {}
int	prfstat;
#endif
*/

/*
 * configurable, driver specific, drive independent space declaration
 */
#include "sys/iobuf.h"

#if defined(VME321_0)|defined(VME350_0)
#include "sys/bpp.h"
#endif

#ifdef	VME320_0
#include "sys/space/m320space.h"
#endif

#ifdef	VME321_0
#include "sys/space/m321space.h"
#endif

#ifdef	VME323_0
#include "sys/space/m323space.h"
#endif

#ifdef	VME327_0
#include "sys/space/m327space.h"
#endif

#ifdef	VME147_0
#include "sys/space/m147space.h"
#endif

#ifdef	VME331_0
#include "sys/space/m331space.h"
#endif

#ifdef	VME350_0
#include "sys/space/m350space.h"
#endif

#ifdef	VME360_0
#include "sys/space/m360space.h"
#endif

#if DBUF != 0
#include "sys/space/dbufspace.h"
#endif

#include	"sys/ipc.h"
#include	"sys/msg.h"

char	msglock[MSGMNI];
struct map	msgmap[MSGMAP];
struct msqid_ds	msgque[MSGMNI];
struct msg	msgh[MSGTQL];
struct msginfo	msginfo = {
	MSGMAP,
	MSGMAX,
	MSGMNB,
	MSGMNI,
	MSGSSZ,
	MSGTQL,
	MSGSEG
};

#include	"sys/sem.h"
struct semid_ds	sema[SEMMNI];
struct sem	sem[SEMMNS];
struct map	semmap[SEMMAP];
struct	sem_undo	*sem_undo[NPROC];
#define	SEMUSZ	(sizeof(struct sem_undo)+sizeof(struct undo)*SEMUME)
int	semu[((SEMUSZ*SEMMNU)+NBPW-1)/NBPW];
union {
	short		semvals[SEMMSL];
	struct semid_ds	ds;
	struct sembuf	semops[SEMOPM];
}	semtmp;

struct	seminfo seminfo = {
	SEMMAP,
	SEMMNI,
	SEMMNS,
	SEMMNU,
	SEMMSL,
	SEMOPM,
	SEMUME,
	SEMUSZ,
	SEMVMX,
	SEMAEM
};

#include	"sys/shm.h"
struct shmid_ds	shmem[SHMMNI];
struct	shminfo	shminfo	= {
	SHMMAX,
	SHMMIN,
	SHMMNI,
	SHMSEG,
	SHMBRK,
	SHMALL
};

/* file and record locking */
#include "sys/flock.h"
struct flckinfo flckinfo = {
	FLCKREC
} ;

struct filock flox[FLCKREC];		/* lock structures */

/* parity error check routines table */
extern int m204parity(), cpparity(), m143parity(), m147parity();
int (*chkpartbl[])() = {
#ifdef M204
	m204parity,
#endif
#ifdef CPRAM
	cpparity,
#endif
#ifdef MEM143_0
	m143parity,
#endif
#ifdef MEM147_0
	m147parity,
#endif
	NULL
};

int paritymode = PARITYMODE;
int parityon = PARITYON;

/*
 * generic tape device list
 */

#include "sys/gentape.h"
	/* FVME250 code for generic tape driver */ 
int f250_ctladdr = F250CTLADR;
int f250_tskaddr = F250TSKADR;
#ifdef  FVME250_0
extern int ps_0_cmaj, ps_0_bmaj;
int *b250_maj = &ps_0_bmaj;
int *c250_maj = &ps_0_cmaj;
#else
int *b250_maj = NULL;
int *c250_maj = NULL;
#endif
#ifdef	VME147_0
extern int t147_addr[], t147_bmaj, t147_cmaj;
int *b147_maj = &t147_bmaj;
int *c147_maj = &t147_cmaj;
#else
int *b147_maj = NULL;
int *c147_maj = NULL;
#endif
#ifdef	VME327_0
extern int t327_addr[], t327_bmaj, t327_cmaj;
int *b327_maj = &t327_bmaj;
int *c327_maj = &t327_cmaj;
#else
int *b327_maj = NULL;
int *c327_maj = NULL;
#endif
#ifdef	VME350_0
extern int m350_addr[], m350_bmaj, m350_cmaj;
int *b350_maj = &m350_bmaj;
int *c350_maj = &m350_cmaj;
#else
int *b350_maj = NULL;
int *c350_maj = NULL;
#endif

int *btape_maj =
#ifdef BTAPEDEV
#if defined(VME147_0) && BTAPEDEV == 147
    &t147_bmaj;
#elif defined(VME327_0) && BTAPEDEV == 327
    &t327_bmaj;
#elif defined(VME350_0) && BTAPEDEV == 350
    &m350_bmaj;
#elif defined(FVME250_0) && BTAPEDEV == 250
    &ps_0_bmaj;
#else
    NULL;
#endif
#else
    NULL;
#endif

int *ctape_maj =
#ifdef CTAPEDEV
#if defined(VME147_0) && CTAPEDEV == 147
    &t147_cmaj;
#elif defined(VME327_0) && CTAPEDEV == 327
    &t327_cmaj;
#elif defined(VME350_0) && CTAPEDEV == 350
    &m350_cmaj;
#elif defined(FVME250_0) && CTAPEDEV == 250
    &ps_0_cmaj;
#else
    NULL;
#endif
#else
    NULL;
#endif

struct gentape gt_list[] = {
#ifdef	VME147_0
{ &t147_addr[0], &t147_bmaj, &t147_cmaj, VME147 },
#endif
#ifdef	VME327_0
{ &t327_addr[0], &t327_bmaj, &t327_cmaj, 0 },
#endif
#ifdef	VME350_0
{ &m350_addr[0], &m350_bmaj, &m350_cmaj, 0 },
#endif
{ NULL, NULL, NULL, 0 }
};


struct gentape f250_list = {
	(int *)0,
	&ps_0_bmaj,
	&ps_0_cmaj,
	0
};

	/* Table to convert generic tape driver minor device numbers to 
	   fvme250 tape driver minor device numbers.
	   The fvme250 tape driver cannot append data.
	*/
 
short f250_minor[8] = {
	69,		/* 0 - Truncate/Rewind on close/Retension */
	68,		/* 1 - Truncate/Retension */
	69,		/* 2 - Append/Retension/Rewind on close */
	68,		/* 3 - Append/Retension */
	65,		/* 4 - Truncate/Rewind on close */
	64,		/* 5 - Truncate */
	65,		/* 6 - Append/Rewind on close */
	64		/* 7 - Append */
};	



/* Streams */
#ifdef STREAMS
#include "sys/stream.h"
queue_t queue[NQUEUE];
struct stdata streams[NSTREAM];
mblk_t mblock[NBLK32768+NBLK16384+NBLK8192+NBLK4096+NBLK2048+NBLK1024+NBLK512+NBLK256+NBLK128+NBLK64+NBLK16+NBLK4 + ((NBLK32768+NBLK16384+NBLK8192+NBLK4096+NBLK2048+NBLK1024+NBLK512+NBLK256+NBLK128+NBLK64+NBLK16+NBLK4)/4)];
dblk_t dblock[NBLK32768+NBLK16384+NBLK8192+NBLK4096+NBLK2048+NBLK1024+NBLK512+NBLK256+NBLK128+NBLK64+NBLK16+NBLK4];
struct linkblk linkblk[NMUXLINK];
int nmuxlink ={NMUXLINK};
int nstrpush ={NSTRPUSH};
struct strevent strevent[NSTREVENT];
int nstrevent ={NSTREVENT};
int maxsepgcnt ={MAXSEPGCNT};
int strmsgsz ={STRMSGSZ};
int strctlsz ={STRCTLSZ};
char strlofrac  ={STRLOFRAC};
char strmedfrac ={STRMEDFRAC};
int nmblock ={NBLK32768+NBLK16384+NBLK8192+NBLK4096+NBLK2048+NBLK1024+NBLK512+NBLK256+NBLK128+NBLK64+NBLK16+NBLK4 + ((NBLK32768+NBLK16384+NBLK8192+NBLK4096+NBLK2048+NBLK1024+NBLK512+NBLK256+NBLK128+NBLK64+NBLK16+NBLK4)/4)};
#endif

/* DU */
#ifdef DU
struct srmnt srmount[NSRMOUNT];
int nsrmount ={ NSRMOUNT };
int nservers ={ 0 };
int idleserver ={ 0 };
int msglistcnt ={ 0 };

#include "sys/adv.h"
#include "sys/sema.h"
#include "sys/comm.h"
#include "sys/nserve.h"
#include "sys/cirmgr.h"
struct advertise advertise[NADVERTISE];
int nadvertise = NADVERTISE;
struct rcvd rcvd[NRCVD];
int nrcvd = NRCVD;
struct sndd sndd[NSNDD];
int nsndd = NSNDD;
struct gdp gdp[MAXGDP];
int maxgdp = MAXGDP;
int minserve = MINSERVE;
int maxserve = MAXSERVE;
int nrduser = NRDUSER;
struct rd_user rd_user[NRDUSER];
unsigned char rfheap[RFHEAP];
int rfsize = RFHEAP;
int rfs_vhigh = RFS_VHIGH;
int rfs_vlow = RFS_VLOW;
#endif

int (*io_start[])()={
	0
	};

short ipid[NINODE];
int	ilogsize=0;
int	ilogs[1];

#include "sys/fsid.h"
#include "sys/fstyp.h"
struct fsinfo fsinfo[] = {
/*    flags	pipe   name   notify	*/
	0,	NULL,	"",	0,
	0,	NULL,	S51K,	0,
FS_NOICACHE,	NULL,	DUFST,	0,
FS_RECYCLE,	NULL,	"NFS",	0,	
};

#ifdef STREAMS
#include "sys/log.h"
#include "sys/streams.h"
#endif

#include "sys/linesw.h"

#include "sys/space/ispspace.h"

#ifdef GREEK
int greek = GREEK;
#else
int greek = 0;
#endif /* GREEK */
