
/*		Copyright (c) 1988 Motorola Inc.	*/
/*		All Rights Reserved			*/
/* 		@(#)m147space.h	35.7		*/
/*
 *	This file contains external definitions for
 *	the MVME147 SCSI Controller driver.
 */

#define	M147CTLS	1

#define	M147DSKS	8		/* maximum disks on an MVME147 */

#include "sys/dsk.h"
#include "sys/scsi.h"
#include "sys/mvme147s.h"
#include "sys/disjointio.h"

struct	scs_pkt	m147pkt[M147PKTS];
struct	scs_pkt	*m147freeq;		/* one and only one */



#define m147sa(x)	tabinit(0,&m147stat[x].ios)

/* one entry for each device */
/* Note: only set up for one device per SCSI address */

struct	iotime		m147stat[ M147CTLS * MAXSCADR * MAXSCDEV];

struct	iobuf		m147utab[ M147CTLS * MAXSCADR * MAXSCDEV] = {
	m147sa(0), m147sa(1), m147sa(2), m147sa(3),
	m147sa(4), m147sa(5), m147sa(6), m147sa(7), 
};
#undef	m147sa


#ifndef VME320_0
#include "sys/open.h"
#endif
int	d147otbl[ M147CTLS * MAXSCADR * MAXSCDEV * OTYPCNT];

int m147maxscadr = MAXSCADR;		/* max number of configured addrs */
int m147maxscdev = MAXSCDEV;		/* max number of configured devs */
int m147maxtab = MAXSCADR * MAXSCDEV; /* max table size */

/*
 *	Tape Specific
 */


struct	iostat t147iostp[M147CTLS];

int t147maxbsize = T147MAXBSIZE;	/* maximum size of dma buffers */




struct scs_disk m147cdcwrenIII = 	{
	 {
			0, /* null fill		*/
			0,	/* step rate		*/
			0,	/* null fill 		*/
			9,	/* number of heads	*/
			967,	/* number of cylinders	*/
			0,	/* pre-compensation cyl	*/
			35,	/* sectors per track	*/
			0,	/* null fill 		*/
			0x50,	/* disk attribute	*/
			0x10,	/* controller type	*/
			DISK },	/* peripheral type	*/
			{ 0,				
			10,	/* retry count		*/
			512,	/* bytes per sector	*/
			0,	/* sector slip count	*/
			100,	/* number of alternates */
			0 } /* null fill		*/
};

struct scs_disk m147cdcwrenIV  = {
	{
			0, /* null fill		*/
			0,	/* step rate		*/
			0x00, 	/* cache enable 0=on, 80=off 	*/
			9, 	/* number of heads	*/
			0x584,	/* number of cylinders	*/
			0,	/* pre-compensation cyl	*/
			47,	/* sectors per track	*/
			0, 	/* null fill		*/
			0x50,	/* disk attribute 	*/
			0x13,	/* controller type	*/
			DISK },	/* peripheral type	*/
			{ 0, 	/* null fill		*/
			10,	/* retry count		*/
			512,	/* bytes per sector	*/
			0,	/* sector slip		*/
			100,	/* number of alternates */
			0 } 	/* null fill		*/
};

struct scs_disk m147micro1375 	= {
	{
			0, /* null fill		*/
			0,	/* step rate		*/
			0, 	/* null fill		*/
			8, 	/* number of heads	*/
			1024,	/* number of cylinders	*/
			0,	/* pre-compensation cyl	*/
			36,	/* sectors per track	*/
			0, 	/* null fill		*/
			0x50, 	/* disk attribute	*/
			0x11,	/* controller type	*/
			DISK },	/* peripheral type	*/
			{ 0, 	/* null fill		*/
			10,	/* retry count		*/
			512,	/* bytes per sector	*/
			0,	/* sector slip count	*/
			0,	/* number of alternates */
			0 }	/* null fill 		*/
};

struct scs_disk m147mini40 	= {
	 { 
			0, /* null fill		*/
			0,	/* step rate		*/
			0, 	/* null fill		*/
			6, 	/* number of heads	*/
			615,	/* number of cylinders	*/
			0,	/* pre-compensation cyl	*/
			26,	/* sectors per track	*/
			0, 	/* null fill		*/
			0x850,	/* disk attributes	*/
			0x0f,	/* controller type	*/
			DISK },	/* peripheral type	*/
			{ 0, 	/* null fill		*/
			10,	/* retry count		*/
			512,	/* bytes per sector	*/
			0,	/* sector slip count 	*/
			0,	/* number of alternates */
			0 }	/* null entry 		*/
};
struct scs_disk m147seagate40 	= {
	 { 
			0, /* null fill		*/
			0,	/* step rate		*/
			0, 	/* null fill		*/
			6, 	/* number of heads	*/
			613,	/* number of cylinders	*/
			0,	/* pre-compensation cyl	*/
			26,	/* sectors per track	*/
			0, 	/* null fill		*/
			0x850,	/* disk attributes	*/
			0x0f,	/* controller type	*/
			DISK },	/* peripheral type	*/
			{ 0, 	/* null fill		*/
			10,	/* retry count		*/
			512,	/* bytes per sector	*/
			0,	/* sector slip count 	*/
			0,	/* number of alternates */
			0 }	/* null entry 		*/
};
	
struct scs_disk m147seagate80  	= {
	{ 
			0, /* null fill		*/
			0,	/* step rate		*/
			0, 	/* null fill		*/
			6, 	/* number of heads	*/
			818,	/* number of cylinders	*/
			0,	/* pre-compensation cyl	*/
			0x22,	/* sectors per track	*/
			0, 	/* null fill		*/
			0x850,	/* disk attributes	*/
			0x14,	/* controller type	*/
			DISK },	/* peripheral type	*/
			{ 0, 	/* null fill		*/
			10,	/* retry count		*/
			512,	/* bytes per sector	*/
			0,	/* sector slip count	*/
			0,	/* number of alternates */
			0 }	/* null entry 		*/
};

struct scs_disk m147dsdd5 	= {
	 { 
			0, /* null fill	*/
			100,	/* step rate		*/
			0, 	/* null fill		*/
			2, 	/* number of heads	*/
			80,	/* number of cylinders	*/
			80,	/* pre-compensation cyl	*/
			16,	/* sectors per track	*/
			0, 	/* null fill		*/
			0x0207,	/* disk attributes	*/
			0x0f,	/* controller type	*/
			FLOP }, 	/* peripheral type	*/
			{ 0, 	/* null fill		*/
			10,	/* retry count		*/
			256,	/* bytes per sector	*/
			0,	/* sector slip count	*/
			0,	/* number of alternates */
			0 }	/* null entry 		*/
};

struct scs_disk m147pcat = {
	 { 
			0, /* null fill	*/
			100,	/* step rate		*/
			0, 	/* null fill		*/
			2, 	/* number of heads	*/
			80,	/* number of cylinders	*/
			80,	/* pre-compensation cyl	*/
			15,	/* sectors per track	*/
			0, 	/* null fill		*/
			0x028f,	/* disk attributes	*/
			0x0f,	/* controller type	*/
			FLOP }, 	/* peripheral type	*/
			{ 0, 	/* null fill		*/
			10,	/* retry count		*/
			512,	/* bytes per sector	*/
			0,	/* sector slip count	*/
			0,	/* number of alternates */
			0 }	/* null entry 		*/
};


struct scs_disk m147ccs 	= {
	 { 
			0, /* null fill		*/
			0,	/* step rate		*/
			0, 	/* null fill		*/
			255, 	/* number of heads	*/
			2048,	/* number of cylinders	*/
			2048,	/* pre-compensation cyl	*/
			255,	/* sectors per track	*/
			0, 	/* null fill		*/
			0x50,	/* disk attributes	*/
			0x0f,	/* controller type	*/
			DISK },	/* peripheral type	*/
			{ 0, 	/* null fill		*/
			10,	/* retry count		*/
			512,	/* bytes per sector	*/
			0,	/* sector slip count 	*/
			0,	/* number of alternates */
			0 }	/* null entry 		*/
};

struct scs_tape m147archive = {
	{
	 		0,	/* null fill			*/
			5,	/* number of physical tracks	*/
			0,	/* null fill			*/
			1,	/* minimum read xfer		*/
			0,	/* null fill			*/
			1,	/* minimum write xfer		*/
			0,	/* null fill			*/
			100,	/* streaming count		*/
			0,	/* null fill			*/
			0,	/* null fill			*/
			0x0001,	/* tape attributes		*/
			0x12,	/* controller type		*/
			TAPE },	/* drive type			*/
			{ 0,	/* null fill			*/
			  10,	/* retrys */
			512,	/* bytes per block		*/
			 0,	/* null fill			*/
			 0 }	/* work area 			*/
};


struct scs_disk m147disk = {{0,0,0,0,0,0,0,0,0x50,0x0f,DISK},{0,0,512,0,0,0}};
struct scs_disk m147empty = {{0,0,0,0,0,0,0,0,0,0,0},{0,0,0,0,0,0}};

/*
 *	Default Parameter Tables
*/

struct scs_disk *m147params[] = {
	&m147cdcwrenIII,
	&m147micro1375,
	&m147cdcwrenIV,
	&m147seagate80,
	(struct scs_disk *)&m147archive,
	(struct scs_disk *)&m147archive,
	&m147dsdd5,
	&m147empty,  /* host I.D., unusable */
};



/* 
	SCSI disk and tape parameter table to be filled on open
*/

struct scs_disk m147ddefs[] =
{
	{{0},{0}}, {{0},{0}},
	{{0},{0}}, {{0},{0}},
	{{0},{0}}, {{0},{0}},
	{{0},{0}}, {{0},{0}},
};

/*
	Each attached device must have a work buffer.
	It must never be deallocated.
*/
struct  work m147_work[ M147CTLS * MAXSCADR * MAXSCDEV];

/* 147 scatter gather table */
struct  scga	scgalist[M147CTLS * MAXSCADR * MAXSCDEV * D147MAXBLK];

/* disjointio address/byte count list for scatter/gather of raw I/O */
struct  djntio	d147djlist[M147CTLS * MAXSCADR * MAXSCDEV * D147MAXBLK];

/* coalescing enable flag */
int m147coal = 1;

/* maximum number of entrys in scatter/gather list */
int d147maxblk = D147MAXBLK;
