/*		Copyright (c) 1988 Motorola,Inc.	*/
/*		All Rights Reserved			*/
/* 		@(#)m327space.h	35.5 */
/*
 *	This file contains external definitions for
 *	the MVME327 SCSI Controller driver.
 */

#ifdef	VME327_1
#define	M327CTLS	2
#else
#define	M327CTLS	1
#endif

#define	M327DSKS	8		/* maximum disks on an MVME327 */

#include "sys/sobpp.h"
#include "sys/mvme327.h"

struct	sb_packet	m327pkt[M327CTLS*M327MAXSCBUS*M327PKTS];
struct	sb_envelope	m327env[M327CTLS*M327MAXSCBUS*M327PKTS];
/* one channel per mvme327a board or one per mvme327b bus */
struct	sb_channel	d327chan[M327CTLS*M327MAXSCBUS]; 
struct	sb_envelope	*m327freeq;		/* one and only one */



#define m327sa(x)	tabinit(0,&m327stat[x].ios)

/* one entry for each device */
/* Note: only set up for one device per SCSI address */

struct	iotime		m327stat[ M327CTLS * M327MAXSCBUS * M327MAXSCADR * M327MAXSCDEV];
struct	iobuf		m327utab[ M327CTLS * M327MAXSCBUS * M327MAXSCADR * M327MAXSCDEV] = {
	m327sa(0), m327sa(1), m327sa(2), m327sa(3),
	m327sa(4), m327sa(5), m327sa(6), m327sa(7), 
#if M327CTLS > 1
	m327sa(8),m327sa(9), m327sa(10), m327sa(11), m327sa(12),
	m327sa(13), m327sa(14), m327sa(15), 
#endif
};
#undef	m327sa

struct d_disk m327desc [ M327CTLS * M327MAXSCBUS * M327MAXSCADR * M327MAXSCDEV ];

/* floppy */

#define m327fsa(x)	tabinit(0,&m327fstat[x].ios) /* floppy */

struct	iotime		m327fstat[ 2 * M327CTLS ];
struct	iobuf		m327futab[ 2 * M327CTLS ] = {
	m327fsa(0), m327fsa(1),
#if M327CTLS > 1
	m327fsa(2), m327fsa(3),
#endif
};

#undef	m327fsa

#ifndef VME320_0
#include "sys/open.h"
#endif
int	d327otbl[ M327CTLS * M327MAXSCBUS * M327MAXSCADR * M327MAXSCDEV * OTYPCNT];

/* floppy open table */
int	d327fotbl[ M327CTLS * 2 * OTYPCNT];

/* floppy descriptor table, filled on open() */
struct d_disk m327fdesc [] =
{
	{ EMPTY },
	{ EMPTY },
#if M327CTLS > 1
	{ EMPTY },
	{ EMPTY },
#endif
};

int m327maxscbus = M327MAXSCBUS;	/* max number of configured buses */
int m327maxscadr = M327MAXSCADR;	/* max number of configured addrs */
int m327maxscdev = M327MAXSCDEV;	/* max number of configured devs */
int m327maxtab = M327CTLS*M327MAXSCBUS*M327MAXSCADR*M327MAXSCDEV; /* max table size */

int m327maxcoal = M327MAXCOAL;		/* max number of coalesced buffers */

/* type of board flag */
int m327a = M327A;

/*
 *	Tape Specific
 */


struct sb_channel t327chan[M327CTLS*M327MAXSCBUS];	/* channels - one per bus */

struct	iostat t327iostp[M327CTLS*M327MAXSCBUS];

int t327maxbsize = T327MAXBSIZE;	/* maximum size of dma buffers */


/*
 *	Default Parameter Tables
 */

struct t_tape m327archive= 
	{ ARCHIVE }
;
struct d_disk m327empty= 
	{ EMPTY }
;
struct d_disk m327diskdevice= 
	{ DISKDEVICE }
;

struct d_disk *m327params [] =
{
/* SCSI Address		Device 0 */
/* 0 */			&m327diskdevice,
/* 1 */			&m327diskdevice,
/* 2 */			&m327diskdevice,
/* 3 */			&m327diskdevice,
/* 4 */			(struct d_disk *)&m327archive,
/* 5 */			(struct d_disk *)&m327archive,
/* 6 */			&m327empty,
/* 7 */			&m327empty,
#if M327CTLS > 1
/* 0 */			&m327diskdevice,
/* 1 */			&m327diskdevice,
/* 2 */			&m327diskdevice,
/* 3 */			&m327diskdevice,
/* 4 */			(struct d_disk *)&m327archive,
/* 5 */			(struct d_disk *)&m327archive,
/* 6 */			&m327empty,
/* 7 */			&m327empty,
#endif
};

struct d_disk m327dsddflop= 

	{ DSDDFLOP }
;

struct d_disk m327pcatflop= 

	{ PCATFLOP }
;

struct d_disk *f327params[] = {

	&m327dsddflop,
	&m327pcatflop
};

/* the scatter/gather list is allocated on a per device basis */
struct  sb_scatlist m327scatlist[M327CTLS * MAXSCADR * MAXSCDEV * M327MAXCOAL];

/* coalescing enable flag */
int m327coal = 1;
