/*	Copyright (c) 1984 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

#ident	"@(#)kern-port:sys/sysm68k.h	35.4"

/*
 * Commands for sysm68k system call 
 */

#ifdef m88k

#define	S88CONT		2	/* Instr. cont. after signal handlers	*/
#define S88FPEX		3	/* floating point exception	*/
#define	S88STIME	4	/* Set internal time only 		*/
#define	S88SETNAME	5	/* Rename the sytem			*/
#define	S88RTODC	6	/* read time of day clock		*/
#define	S88DELMEM	9	/* Delete available memory for testing	*/
#define	S88ADDMEM	10	/* Return previously deleted memory	*/
#define	S88MEMSIZE	11	/* return the memory size of system	*/
#define	S88SWAP		12	/* Manipulate swap space (see swap.h)	*/
#define	S88HW		13	/* status of floating point hardware	*/
#define	S88CACHEON	14	/* Turn CMMU cache on	*/
#define	S88CACHEOFF	15	/* Turn CMMU cache off	*/
#define S88CACHEFLUSH   16      /* Flush CMMU cache.          */

#else

#define	S68STACK	1	/* Grow user stack on the MC68000 	*/
#define	S68CONT		2	/* Instr. cont. after signal handlers	*/
#define S68FPEX		3	/* MC68881 floating point exception	*/
#define	S68STIME	4	/* Set time (internal and todc)		*/
#define	S68SETNAME	5	/* Rename the sytem			*/
#define	S68RTODC	6	/* read time of day clock		*/
#define	S68ICACHEON	7	/* Turn internal chip cache on 		*/
#define	S68ICACHEOFF	8	/* Turn internal chip cache off		*/
#define	S68DELMEM	9	/* Delete available memory for testing	*/
#define	S68ADDMEM	10	/* Return previously deleted memory	*/
#define	S68MEMSIZE	11	/* return the memory size of system	*/
#define	S68SWAP		12	/* Manipulate swap space (see swap.h)	*/
#define	S68FPHW		13	/* status of floating point hardware	*/
#define	S68BCACHEON	14	/* Turn MVME131XT board cache on	*/
#define	S68BCACHEOFF	15	/* Turn MVME131XT board cache off	*/
#define S68BIURW	16	/* Read/write MC68881 BIU flags		*/
#define S68CPUBRD	17	/* return cpuboard value to user	*/
#define S68TODCSTAT	18	/* Request status on time of day clock	*/
#define	S68CACHESET	19	/* Set chip cache control register	*/
#define	S68CACHERD	20	/* Read chip cache control register	*/
#define	S68BRDSTAT	21	/* return structure for brd status	*/
#define	S68WPOSTON	22	/* turn write posting on		*/
#define	S68WPOSTOFF	23	/* turn write posting off		*/

/*
 *	Arguments and return values for above system calls
 */

#define	NOFPHW		0	/* No floating point hardware present	*/
#define	MC68881		1	/* MC-68881 floating point coprocessor	*/
#define GOOD_TODC	3	/* todc exists and holds a valid time	*/

/*         cache control register on 68020 and 68030
 *
 *      31                     24 23                    16
 *       +-----------------------+----------------------+
 *       |         Zero          |         Zero         |
 *       +-----------------------+----------------------+
 *                   8                       8
 *      15                      8 7                     0
 *       +-----------------------+----------------------+
 *       |0|0|WA|DBE|CD|CED|FD|ED|0|0|0|IBE|CI|CEI|FI|EI|
 *       +-----------------------+----------------------+
 *                   8                       8
 *
 */
typedef union cacr {
	struct {
		unsigned int
			cacr_z0    : 18, /* Zero Reserved */
			cacr_wa    : 1,  /* Write Allocate */
			cacr_dbe   : 1,  /* Data Burst Enable */
			cacr_cd    : 1,  /* Clear Data Cache */
			cacr_ced   : 1,  /* Clear Entry in Data Cache */
			cacr_fd    : 1,  /* Freeze Data Cache */
			cacr_ed	   : 1,  /* Enable Data Cache */
			cacr_z1	   : 3,  /* Zero Reserved */
			cacr_ibe   : 1,  /* Instruction Burst Enable */
			cacr_ci	   : 1,  /* Clear Instruction Cache */
			cacr_cei   : 1,  /* Clear Entry in Instruction Cache */
			cacr_fi	   : 1,  /* Freeze Instruction Cache */
			cacr_ei	   : 1   /* Enable Instruction Cache */
	} cacm;

	struct {
		unsigned int
			cacr_cacr;	/*  cache control register */
	} caci;
} cacr_t;


/*
 *	Mnemonics for S68CACHESET and S68CACHERD calls
 */

#define	CACR_EI		0x0001	/* Enable Instruction Cache		*/
#define	CACR_FI		0x0002	/* Freeze Instruction Cache		*/
#define	CACR_CEI	0x0004	/* Clear Entry in Instruction Cache	*/
#define	CACR_CI		0x0008	/* Clear Instruction Cache		*/
#define	CACR_IBE	0x0010	/* Instruction Burst Enable		*/
#define	CACR_ED		0x0100	/* Enable Data Cache 			*/
#define	CACR_FD		0x0200	/* Freeze Data Cache			*/
#define	CACR_CED	0x0400	/* Clear Entry in Data Cache		*/
#define	CACR_CD		0x0800	/* Clear Data Cache			*/
#define	CACR_DBE	0x1000	/* Data Burst Enable			*/
#define	CACR_WA		0x2000	/* Write Allocate			*/

#endif /* m88k */
